/* sms (c) James McKay */

/* includes and definitions from the main body */

#define JPort 0x201

word js_a_x, js_a_y, js_b_x, js_b_y;
word js_a_1, js_a_2, js_b_1, js_b_2;
word up_A, up_B, down_A, down_B;
word left_A, left_B, right_A, right_B;
word centre_x_A, centre_x_B, centre_y_A, centre_y_B;
UC joy_present=0;

void Joy_Detect(void)
{
	word timeout;

	joy_present=0;
	_disable();
	timeout=65535;
	outp(JPort,1);
	do
	{
		if(!(inp(JPort)&1)) break;
	} while(timeout--);
	_enable();
	if(timeout==65535)
	{
		return;
	}
	joy_present=1;
	printf("Joystick A : Yes %u\n",timeout);

	_disable();
	timeout=65535;
	outp(JPort,1);
	do
	{
		if(!(inp(JPort)&4)) break;
	} while(timeout--);
	_enable();
	if(timeout==65535)
	{
		return;
	}
	joy_present=2;
	printf("Joystick B : Yes %u\n",timeout);
}

void Poll_Joystick(void)
{
	UC value;

	if(!joy_present) return;
	js_a_x=js_a_y=js_b_x=js_b_y=0;
	js_a_1=js_a_2=js_b_1=js_b_2=0;
	switch(joy_present)
	{
		case 1:
			_disable();
			outp(JPort,0);
			do
			{
				value=inp(JPort)&0x03;
				if(!value) break;
				if(value&1) js_a_x++;
				if(value&2) js_a_y++;
			} while(1);
			break;
		case 2:
			_disable();
			outp(JPort,0);
			do
			{
				value=inp(JPort)&0x0F;
				if(!value) break;
				if(value&1) js_a_x++;
				if(value&2) js_a_y++;
				if(value&4) js_b_x++;
				if(value&8) js_b_y++;
			} while(1);
			break;
		default:
			break;
	}
	value=inp(JPort);
	if(value&16) js_a_1=1;
	if(value&32) js_a_2=1;
	if(value&64) js_b_1=1;
	if(value&128) js_b_2=1;
	_enable();
}

void calibrate_joysticks(void)
{
	word disp_x_A, disp_y_A, disp_x_B, disp_y_B;

	poll_joystick(); /* Assume both centred! */
	centre_x_A=js_a_x;
	centre_x_B=js_b_x;
	disp_x_A=centre_x_A/5;
	disp_x_B=centre_x_B/5;
	printf("disp_x_A=%u disp_x_B=%u\n",disp_x_A,disp_x_B);
	right_A=centre_x_A+disp_x_A;
	right_B=centre_x_B+disp_x_B;
	left_A=centre_x_A-disp_x_A;
	left_B=centre_x_B-disp_x_B;

	centre_y_A=js_a_y;
	centre_y_B=js_b_y;
	disp_y_A=centre_y_A/5;
	disp_y_B=centre_y_B/5;
	printf("disp_y_A=%u disp_y_B=%u\n",disp_y_A,disp_y_B);
	down_A=centre_y_A+disp_y_A;
	down_B=centre_y_B+disp_y_B;
	up_A=centre_y_A-disp_y_A;
	up_B=centre_y_B-disp_y_B;
}
