/******************************************/
/**                                      **/
/**          SMS_DEF Portable File       **/
/**                                      **/
/**          (C) James McKay 1996        **/
/**                                      **/
/**    This software may not be used     **/
/**    for commercial reasons, the code  **/
/**    may not be modified or reused     **/
/**    without permission.               **/
/**                                      **/
/******************************************/
#define SET_CF_P ptemp.B.l|=1   /* set Cf */
#define RES_CF_P ptemp.B.l&=254 /* reset Cf */

#define SET_NF_P ptemp.B.l|=2   /* set Nf */
#define RES_NF_P ptemp.B.l&=253 /* reset Nf */

#define SET_PF_P ptemp.B.l|=4   /* set Pf */
#define RES_PF_P ptemp.B.l&=251 /* reset Pf */

#define SET_3F_P ptemp.B.l|=8   /* set bit 3 of F */
#define RES_3F_P ptemp.B.l&=247 /* reset bit 3 of F */

#define SET_HF_P ptemp.B.l|=16  /* set Hf */
#define RES_HF_P ptemp.B.l&=239 /* reset Hf */

#define SET_5F_P ptemp.B.l|=32  /* set bit 5 of F */
#define RES_5F_P ptemp.B.l&=223 /* reset bit 5 of F */

#define SET_ZF_P ptemp.B.l|=64  /* set Zf */
#define RES_ZF_P ptemp.B.l&=191 /* reset Zf */

#define SET_SF_P ptemp.B.l|=128 /* set Sf */
#define RES_SF_P ptemp.B.l&=127 /* reset Sf */

#define INC_R_REG \
	ir.B.l++

#ifdef MAIN_OBJ
void mem_page_sys(void)
{
	switch(mps_oset)
	{
		case 0xFFFC:
			BRAM_page=mps_bpval;
			if(BRAM_page&8)
			{
				SRAMW[4]=SRAMR[4]=BRAM[(BRAM_page>>2)&1];
				SRAMW[5]=SRAMR[5]=SRAMR[4]+8192;
			}
			else
			{
				SRAMR[4]=ROM[ROM_pager];
				SRAMR[5]=SRAMR[4]+8192;
				SRAMW[4]=SRAMW[5]=DUMMY_MEM;
			}
			break;
		case 0xFFFD: break;
		case 0xFFFE:
			ROM_4000=mps_bpval&rom_limit;
			RAM_C000[8190]=ROM_4000;
			SRAMR[2]=ROM[ROM_4000];
			SRAMR[3]=SRAMR[2]+8192;
			break;
		case 0xFFFF:
			ROM_pager=mps_bpval&rom_limit;
			RAM_C000[8191]=ROM_pager;
			if(!(BRAM_page&8))
			{
				SRAMR[4]=ROM[ROM_pager];
				SRAMR[5]=SRAMR[4]+8192;
				SRAMW[4]=SRAMW[5]=DUMMY_MEM;
			}
			break;
	}
}
#else
void mem_page_sys(void);
#endif

#define spokeb(oset,bpval) \
	SRAMW[oset>>13][oset&0x1FFF]=bpval; \
	if(oset>0xFFFB) \
	{ \
		mps_oset=oset; \
		mps_bpval=bpval; \
		mem_page_sys(); \
	}

#define speekb(retval,oset) \
	retval=SRAMR[oset>>13][oset&0x1FFF];

#define wordpoke(oset,wpval) \
	ptemp.W=wpval;         \
	spokeb(oset,ptemp.B.l);  \
	spokeb(oset+1,ptemp.B.h);

#define wordpeek(retval,oset) \
	speekb(ptemp.B.l,oset); \
	speekb(ptemp.B.h,oset+1); \
	retval=ptemp.W;

#define push(wpval) \
	sp.W-=2; \
	wordpoke(sp.W,wpval);

#define pop(wpval) \
	wordpeek(wpval,sp.W); \
	sp.W+=2;

#define copy_b53(btemp) \
	af.B.l=(af.B.l&215)|(btemp&40);

#ifdef NO_POTATO

/* Keep SZ Depends 543 Keep P Res NC */
#define add16(first,second) \
	qtemp.Q=(unsigned long)first+(unsigned long)second; \
	first=qtemp.W.w1; \
	af.B.l=(af.B.l&0xC4)|(qtemp.B.b2&0x38); \
	if (!qtemp.B.b3) RES_CF; else SET_CF;

#else
/*
extern void add16_hla(word reg);

#pragma aux add16_hla="add word ptr [hl],ax"\
		  "lahf"\
		  "and ah,1"\
		  "and byte ptr[af],196"\
		  "or byte ptr [af],ah"\
		  parm [ax]\
		  modify [ax];

#define add16_hl(first,second) \
	add16_hla(second);

extern void add16_ixa(word reg);

#pragma aux add16_ixa="add word ptr [ix],ax"\
		  "lahf"\
		  "and ah,1"\
		  "and byte ptr[af],196"\
		  "or byte ptr [af],ah"\
		  parm [ax]\
		  modify [ax];

#define add16_ix(first,second) \
	add16_ixa(second);

extern void add16_iya(word reg);

#pragma aux add16_iya="add word ptr [iy],ax"\
		  "lahf"\
		  "and ah,1"\
		  "and byte ptr[af],196"\
		  "or byte ptr [af],ah"\
		  parm [ax]\
		  modify [ax];

#define add16_iy(first,second) \
	add16_iya(second);
*/


#define add16(first,second) \
	qtemp.Q=(unsigned long)first+(unsigned long)second; \
	first=qtemp.W.w1; \
	af.B.l=(af.B.l&0xC4)|(qtemp.B.b2&0x38) \
	|(qtemp.B.b3);

#define add16_hl(first,second) add16(first,second);
#define add16_ix(first,second) add16(first,second);
#define add16_iy(first,second) add16(first,second);

#endif


#ifdef NO_POTATO

/* Keep S Res Z Depends 543 Res PNC */
#define adc16(first,second) \
	qtemp.Q=(unsigned long)first+(unsigned long)second+(af.B.l&1); \
	af.B.l=(qtemp.B.b2&0xB8); \
	if (!qtemp.B.b3) RES_CF; else SET_CF; \
	if (qtemp.W.w1) RES_ZF; else SET_ZF; \
	if(((first^qtemp.W.w1)>>15)&&(!((first^second)>>15))) SET_PF; else RES_PF; \
	hl.W=qtemp.W.w1;

#else


#define adc16(first,second) \
	ptemp.W=first+second+(af.B.l&1); \
	af.B.l=(ptemp.B.h&0xB8) \
	|add16_VNC[((first&36864)>>8)|((second&36864)>>9)|((ptemp.B.h&144)>>2)]\
	|(ptemp.W?0:64); \
	hl.W=ptemp.W;

/*
extern void adc16a(word Pls);

#pragma aux adc16a="mov ah, byte ptr [af]"\
		  "sahf"\
		  "adc word ptr [hl],bx"\
		  "lahf"\
		  "jno no_ov_flow"\
		  "and ah,249"\
		  "or ah,4"\
		  "jmp end_mark"\
		  "no_ov_flow: and ah,249"\
		  "end_mark: mov byte ptr [af],ah"\
		  parm [bx]\
		  modify [ah];

#define adc16(Lo,Pls) \
	adc16a(Pls);
*/
#endif

#ifdef NO_POTATO

/* Keep S Res Z Depends 543 Res P Set N Res C */
#define sbc16(first,second) \
	qtemp.Q=(unsigned long)first-(unsigned long)second-(af.B.l&1); \
	af.B.l=(qtemp.B.b2&0xB8)|2; \
	if (!qtemp.B.b4) RES_CF; else SET_CF; \
	if (qtemp.W.w1) RES_ZF; else SET_ZF;  \
	if(((first^qtemp.W.w1)>>15)&&(!((second^qtemp.W.w1)>>15))) SET_PF; else RES_PF; \
	hl.W=qtemp.W.w1;

#else
/*
extern void sbc16a(word Pls);

#pragma aux sbc16a="mov ah, byte ptr [af]"\
		  "sahf"\
		  "sbb word ptr [hl],bx"\
		  "lahf"\
		  "jno no_ov_flow"\
		  "and ah,249"\
		  "or ah,4"\
		  "jmp end_mark"\
		  "no_ov_flow: and ah,249"\
		  "end_mark: mov byte ptr [af],ah"\
		  parm [bx]\
		  modify [ah];

#define sbc16(Lo,Pls) \
	sbc16a(Pls);
*/

#define sbc16(first,second) \
	ptemp.W=first-second-(af.B.l&1); \
	af.B.l=(ptemp.B.h&0xB8) \
	|sub16_VNC[((first&36864)>>8)|((second&36864)>>9)|((ptemp.B.h&144)>>2)]\
	|(ptemp.W?0:64); \
	hl.W=ptemp.W;

#endif

#ifdef NO_POTATO

#define add8(Lo,Pls) \
	ptemp.W=Lo+Pls; \
	if (!ptemp.B.h) \
	{            \
		ptemp.B.h=ptemp.B.l; \
		RES_CF_P;        \
	}                      \
	else                   \
	{                      \
		ptemp.B.h=ptemp.B.l; \
		SET_CF_P;        \
	}                      \
	RES_NF_P;                \
	if (ptemp.B.h) RES_ZF_P; else SET_ZF_P; \
	if ((Lo^Pls^ptemp.B.h)&16) SET_HF_P; else RES_HF_P; \
	if (((Lo^ptemp.B.h)>>7)&&(!((Lo^Pls)>>7))) SET_PF_P; else RES_PF_P; \
	af.W=ptemp.W;

#else
/*
extern void add8a(long Pls);

#pragma aux add8a="add byte ptr [af+1],al"\
		  "lahf"\
		  "jno no_ov_flow"\
		  "and ah,249"\
		  "or ah,4"\
		  "jmp end_mark"\
		  "no_ov_flow: and ah,249"\
		  "end_mark: mov byte ptr [af],ah"\
		  parm [al]\
		  modify [ax];

#define add8(Lo,Pls) \
	add8a(Pls);
*/

#define add8(Lo,Pls) \
	ptemp.B.l=Lo+Pls; \
	af.B.l=add8_table[ptemp.B.l] \
	|add_HVC[(Lo&144)|((Pls&144)>>1)|((ptemp.B.l&144)>>2)]; \
	af.B.h=ptemp.B.l;

#endif

#ifdef NO_POTATO

#define sub8(Lo,Mns) \
	ptemp.W=Lo-Mns; \
	if (!ptemp.B.h)     \
	{                       \
		ptemp.B.h=ptemp.B.l;  \
		RES_CF_P;         \
	}                       \
	else                    \
	{                       \
		ptemp.B.h=ptemp.B.l;  \
		SET_CF_P;         \
	}                       \
	SET_NF_P;                 \
	if (ptemp.B.h) RES_ZF_P; else SET_ZF_P; \
	if ((Lo^Mns^ptemp.B.h)&16) SET_HF_P; else RES_HF_P; \
	if (((Lo^ptemp.B.h)>>7)&&(!((Mns^ptemp.B.h)>>7))) SET_PF_P; else RES_PF_P; \
	af.W=ptemp.W;

#else
/*
extern void sub8a(UC Pls);

#pragma aux sub8a= \
"sub byte ptr [af+1], al"\
"lahf"\
"jno no_ov_flow"\
"and ah,249"\
"or ah,6"\
"jmp end_mark"\
"no_ov_flow: and ah,249"\
"or ah,2"\
"end_mark: mov byte ptr [af],ah"\
parm [al]\
modify [ax];

#define sub8(Lo,Pls) \
	sub8a(Pls);
*/


#define sub8c(Lo,Mns) \
	ptemp.B.l=Lo-Mns; \
	af.B.l=sub8_table[ptemp.B.l] \
	|sub_HVC[(Lo&144)|((Mns&144)>>1)|((ptemp.B.l&144)>>2)]; \
	af.B.h=ptemp.B.l;

#define sub8(Lo,Pls) \
	sub8c(Lo,Pls);

#endif

#ifdef NO_POTATO

#define adc8(Lo,Pls) \
	ptemp.W=Lo+Pls+(af.B.l&1); \
	if (!ptemp.B.h) \
	{            \
		ptemp.B.h=ptemp.B.l; \
		RES_CF_P;        \
	}                      \
	else                   \
	{                      \
		ptemp.B.h=ptemp.B.l; \
		SET_CF_P;        \
	}                      \
	RES_NF_P;                \
	if (ptemp.B.h) RES_ZF_P; else SET_ZF_P; \
	if ((Lo^Pls^ptemp.B.h)&16) SET_HF_P; else RES_HF_P; \
	if (((Lo^ptemp.B.h)>>7)&&(!((Lo^Pls)>>7))) SET_PF_P; else RES_PF_P; \
	af.W=ptemp.W;

#define sbc8(Lo,Mns)                 \
	ptemp.W=Lo-Mns-(af.B.l&1);   \
	if (!ptemp.B.h)              \
	{                            \
		ptemp.B.h=ptemp.B.l; \
		RES_CF_P;            \
	}                            \
	else                         \
	{                            \
		ptemp.B.h=ptemp.B.l; \
		SET_CF_P;            \
	}                            \
	SET_NF_P;                    \
	if (ptemp.B.h) RES_ZF_P; else SET_ZF_P; \
	if((Lo^Mns^ptemp.B.h)&16) SET_HF_P; else RES_HF_P; \
	if(((Lo^ptemp.B.h)>>7)&&(!((Mns^ptemp.B.h)>>7))) SET_PF_P; else RES_PF_P; \
	af.W=ptemp.W;

#else
/*
extern void adc8a(long Pls);

#pragma aux adc8a="mov ah, byte ptr [af]"\
		  "sahf"\
		  "adc byte ptr [af+1],al"\
		  "lahf"\
		  "jno no_ov_flow"\
		  "and ah,249"\
		  "or ah,4"\
		  "jmp end_mark"\
		  "no_ov_flow: and ah,249"\
		  "end_mark: mov byte ptr [af],ah"\
		  parm [al]\
		  modify [ah];

#define adc8(Lo,Pls) \
	adc8a(Pls);
*/
/*
extern void sbc8a(UC Pls);

#pragma aux sbc8a="mov ah, byte ptr [af]"\
		  "sahf"\
		  "sbb byte ptr [af+1],al"\
		  "lahf"\
		  "jno no_ov_flow"\
		  "and ah,249"\
		  "or ah,6"\
		  "jmp end_mark"\
		  "no_ov_flow: and ah,249"\
		  "or ah,2"\
		  "end_mark: mov byte ptr [af],ah"\
		  parm [al]\
		  modify [ah];

#define sbc8(Lo,Pls) \
	sbc8a(Pls);
*/

#define adc8(Lo,Pls) \
	ptemp.B.l=Lo+Pls+(af.B.l&1); \
	af.B.l=add8_table[ptemp.B.l] \
	|add_HVC[(Lo&144)|((Pls&144)>>1)|((ptemp.B.l&144)>>2)]; \
	af.B.h=ptemp.B.l;

#define sbc8(Lo,Mns) \
	ptemp.B.l=Lo-Mns-(af.B.l&1); \
	af.B.l=sub8_table[ptemp.B.l] \
	|sub_HVC[(Lo&144)|((Mns&144)>>1)|((ptemp.B.l&144)>>2)]; \
	af.B.h=ptemp.B.l;

#endif

#ifdef NO_POTATO

#define cp_sub8(Lo,Mns) \
	ptemp.W=Lo-Mns; \
	af.B.l=(Mns&40)|(ptemp.B.l&215)|2; \
	if (ptemp.B.l) RES_ZF; else SET_ZF; \
	if (!ptemp.B.h) RES_CF; else SET_CF; \
	if((Lo^Mns^ptemp.B.l)&16) SET_HF; else RES_HF; \
	if(((Lo^ptemp.B.l)>>7)&&(!((Mns^ptemp.B.l)>>7))) SET_PF; else RES_PF;

#else
/*
extern void cp_sub8a(UC Pls);

#pragma aux cp_sub8a="cmp byte ptr [af+1],al"\
		  "lahf"\
		  "jno no_ov_flow"\
		  "and ah,249"\
		  "or ah,6"\
		  "jmp end_mark"\
		  "no_ov_flow: and ah,249"\
		  "or ah,2"\
		  "end_mark: mov byte ptr [af],ah"\
		  parm [al]\
		  modify [ah];

#define cp_sub8(Lo,Pls) \
	cp_sub8a(Pls);
*/

#define cp_sub8(Lo,Mns) \
	ptemp.B.l=Lo-Mns; \
	af.B.l=cpsub8_table[ptemp.B.l]|(Mns&40) \
	|sub_HVC[(Lo&144)|((Mns&144)>>1)|((ptemp.B.l&144)>>2)]; \

#endif

/*
#define dec8(reg) \
	af.B.l=dec_f[reg]|(af.B.l&1); \
	reg--;

#define inc8(reg) \
	af.B.l=inc_f[reg]|(af.B.l&1); \
	reg++;
*/

extern void dec8a(UC *reg);

#pragma aux dec8a=\
"dec byte ptr [eax]"\
"mov ah,byte ptr [af]"\
"bt ax,8"\
"lahf"\
"jno no_ov_flow"\
"and ah,249"\
"or ah,6"\
"jmp end_mark"\
"no_ov_flow: and ah,249"\
"or ah,2"\
"end_mark: mov byte ptr [af],ah"\
parm[eax]\
modify[eax];
/*
#pragma aux dec8a= \
"dec byte ptr [eax]" \
"lahf"\
"jno no_ov_flow"\
"and ah,248"\
"or ah,6"\
"jmp end_mark"\
"no_ov_flow: and ah,248"\
"or ah,2"\
"end_mark: and byte ptr [af],1"\
"or byte ptr [af],ah"\
parm [eax]\
modify [eax];
*/

#define dec8(reg) \
	dec8a(&reg);



extern void inc8a(UC *reg);

#pragma aux inc8a=\
"inc byte ptr [eax]"\
"mov ah,byte ptr [af]"\
"bt ax,8"\
"lahf"\
"jno no_ov_flow"\
"and ah,249"\
"or ah,4"\
"jmp end_mark"\
"no_ov_flow: and ah,249"\
"end_mark: mov byte ptr [af],ah"\
parm[eax]\
modify[eax];
/*
#pragma aux inc8a= \
"inc byte ptr [eax]" \
"lahf"\
"jno no_ov_flow"\
"and ah,248"\
"or ah,4"\
"jmp end_mark"\
"no_ov_flow: and ah,248"\
"end_mark: and byte ptr [af],1"\
"or byte ptr [af],ah"\
parm [eax]\
modify [eax];
*/
#define inc8(reg) \
	inc8a(&reg);


#ifdef MAIN_OBJ
void calc_parity(UC btemp)
{
	pair temp;
	UC lop,par;

	if(!btemp)
	{
		SET_PF;
	}
	else
	{
		lop=par=0;
		temp.W=(word)btemp;
		do
		{
			temp.W<<=1;
			if(temp.B.h&1) par++;
			lop++;
		} while (lop<8);
		if (par&1) RES_PF; else SET_PF;
	}
}

/* In Unix.c or x128_t.c */
void set_pal_colour(register UC pal_num, register UC colour);
void calc_gg_pal(register UC pal_num);

void line_int_mess_about(void)
{
	if(!LI_method)
	{
		if(vline<64) background_counter=vreg138+1;
		return;
	}
	if(vreg138==255)
	{
		switch(int_255)
		{
			case 0: break; /* No response */
			case 1: /* Immediate Int */
				next_int_line=vline+1;
				if(next_int_line>TOP_LINE/*304*/) next_int_line=64;
				return;
			case 2: /* Delayed Int */
				next_int_line=310;
				return;
			default:
				break;
		}
	}
	switch(LI_method)
	{
		case 1:
			if(vreg138>223/*191*/)
			{
				next_int_line=65535;
			}
			else
			{
				if(vline>63/*vline&192*/)
				{
					next_int_line=vline+vreg138+1;
				}
				else
				{
					next_int_line=vreg138+64;
				}
				if(next_int_line>TOP_LINE/*304*//*255*/)
				{
					next_int_line=vreg138+64;
				}
			}
			break;
		default:
			break;
	}
}

void out_z80(void)
{
	register UC btemp;
	static UC x_posi=0;
	UC nr_btemp;

#define port_lo out_port_lo
#define byte out_byte

	switch(port_lo)
	{
		case  1 :
			port1=byte;
			if(gg_connect)
			{
				send_port1=1;
				port5|=1;
			}
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			break;
		case  2 :
			port2=byte;
			if(gg_connect)
			{
				/*printf("port 2 : %d\n",byte);*/
			}
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			break;
		case  3 :
			port3=byte;
			if(gg_connect)
			{
				send_port3=1;
				port5|=1;
			}
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			break;
		case  5 :
			port5=(port5&7)|(byte&56);
			/*port5=(port5&4)|(byte&251);*/
			if(gg_connect)
			{
				/*printf("port 5 : %d\n",port5);*/
			}
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			break;
		case 63 :
			port63=byte;
			break;
		case 127:
			if(waiting_127)
			{
				waiting_127=0;
				PSGOut(first_127,byte);
			}
			else
			{
				switch((byte&0x70)>>4)
				{
					case 0:
					case 2:
					case 4:
						first_127=byte;
						waiting_127=1;
						break;
					default:
						waiting_127=0;
						PSGOut(byte,0);
						break;
				}
			}
			break;
		case 190:
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"%3d,",nr_btemp);
				x_posi+=4;
				if(x_posi>60)
				{
					x_posi=0;
					fprintf(p_handle,"\n");
				}
			}
#endif
			VIDEO[vdp_addr]=byte;
			if(vdp_pal)
			{
				if(gg_mode)
				{
					calc_gg_pal((vdp_addr)&63);
				}
				else
				{
					VIDEO[vdp_addr]&=63;
				}
			}
			vdp_addr=(vdp_addr+1)&vdp_and;
			/***/
			waiting_191=0;
			/***/
			break;
		case 189:
		case 191:
			if(!waiting_191)
			{
				first_191=byte;
				waiting_191=1;
			}
			else
			{
#ifndef NO_LOG
				if(PSG_open)
				{
					nr_btemp=byte;
					fprintf(p_handle,"\nPort %d : lo %d, hi %d : pc=%u\n",port_lo,first_191,nr_btemp,pc.W);
					if(nr_btemp==138) fprintf(p_handle,"vline is %d\n",vline-64);
					x_posi=0;
				}
#endif
				switch(byte)
				{
					case 128: vreg128=first_191;
						if(vreg128&16)
						{
							line_int=1;
						}
						else
						{
							line_int=0;
						}
						if(vreg128&32)
						{
							left_clip=1;
						}
						else
						{
							left_clip=0;
						}
						sprite_left=vreg128&8;
						top_2_lock=(vreg128&64)>>6;
						right_8_lock=vreg128>>7;
						break;
					case 129:
						vreg129=first_191;
						if(vreg129&64)
						{
							screen_on=1;
						}
						else
						{
							screen_on=0;
						}
						break;
					case 130:
						vreg130=first_191;
						if(vreg128&4)
						{
							scr_map_addr=VRAM+
							(1024*(vreg130&0x0E));
						}
						break;
					case 131: vreg131=first_191;break;
					case 132: vreg132=first_191;break;
					case 133:
						vreg133=first_191;
						sprite_y=VRAM+(((vreg133>>1)<<8)&0x3FFF);
						sprite_x=sprite_y+128;
						break;
					case 134:
						vreg134=first_191;
						if(vreg134&4)
						{
							spr_tile_addr=VRAM+0x2000;
							spr_point=256;
						}
						else
						{
							spr_tile_addr=VRAM;
							spr_point=0;
						}
						break;

					case 135: vreg135=first_191;break;
					case 136: x_scroll=first_191;break;
					case 137: y_scroll=first_191;break;
					case 138:
						vreg138=first_191;
						line_int_mess_about();
						break;
					default :
						break;
				}
				if(byte>191)
				{
					VIDEO=VPAL;
					vdp_pal=1;
					if(gg_mode)
					{
						vdp_and=0x3F;
					}
					else
					{
						vdp_and=0x1F;
					}
					vdp_addr=first_191&vdp_and;
				}
				else
				{
					vdp_addr=((byte&63)<<8)|first_191;
					VIDEO=VRAM;
					vdp_pal=0;
					vdp_and=0x3FFF;
				}

				waiting_191=0;
			}
			break;
		/*case 222:
			port222=byte;
			break;*/
		case 240:
			fm_reg=byte;
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			break;
		case 241:
			fm_chip[fm_reg]=byte;
			if(fm_present)
			{
				fm_out(fm_reg,byte);
			}
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			/*for(nr_btemp=0;nr_btemp<64;nr_btemp+=4)
			{
				printf("%3d %3d %3d %3d\n",fm_chip[nr_btemp],
				fm_chip[nr_btemp+1],fm_chip[nr_btemp+2],
				fm_chip[nr_btemp+3]);
			}
			printf("\n");*/
			break;
		case 242:
			if(fm_present)
			{
				port242=byte;
			}
			break;
		default:
#ifndef NO_LOG
			if(PSG_open)
			{
				nr_btemp=byte;
				fprintf(p_handle,"\nOut %d, %d : pc=%u\n",port_lo,nr_btemp,pc.W);
				x_posi=0;
			}
#endif
			break; /* temporary */
	}
#undef port_lo
#undef byte
}

void in_z80(void)
{
	register UC btemp;

#ifndef NO_LOG
	/*if((in_port_lo!=190)&&(in_port_lo!=191))*/
	{
		if(PSG_open)
		{
			fprintf(p_handle,"\nIN %d : pc=%u\n",in_port_lo,pc.W);
		}
	}
#endif
	switch(in_port_lo)
	{
		case   0:
			in_ret=port0;
			return; /* Game Gear Start */
		case   1:
			if(gg_connect)
			{
				/*printf("port 1 read (%d)\n",port1);*/
				if(port5&2)
				{
					port5&=253;
					read_port4=1;
				}
			}
			in_ret=port1;
			return;
		case   3:
			in_ret=port3;
			return; /* Outrun.GG? */
		case   4:
			if(gg_connect)
			{
				if(port5&2)
				{
					port5&=253;
					read_port4=1;
				}
			}
			in_ret=port4;
			return;
		case   5:
			if(gg_connect)
			{
				/*printf("port 5 read (%d)\n",port5);*/
			}
			in_ret=port5;
			return;
		case 126:
			if(vline>63) /* Hmmm... Must return 0 to unknown */
			{
				in_ret=(vline-64);
				return;
			}
			in_ret=255;
			return; /* Just a guess! */
		case 190:
			waiting_191=0;
			btemp=VIDEO[vdp_addr];
			vdp_addr=(vdp_addr+1)&vdp_and;
			in_ret=btemp;
			return;
		case 191:
			if((vline>63)&&(vline<310)/*vline&192*/)
			{
				in_ret=/*0*/127;
				return;
			}
			in_ret=/*255*/191;
			return;
		case 192:
		case 220:
			in_ret=port220;
			return;
		case 193:
		case 221:
			if((!japan)&&((port63&0x0F)==5))
			{
				if((port63>>4)==0x0F)
				{
					in_ret=(port221|0xC0);
					return;
				}
				else
				{
					in_ret=(port221&0x3F);
					return;
				}
			}
			else
			{
				in_ret=port221;
				return;
			}
		case 222:
			in_ret=port222;
			return;
		case 242:
			in_ret=port242;
			return;
		default :
			in_ret=255;
			return;
	}
	in_ret=255;
	return; /* Urg!  More info needed! */
}
#else
void calc_parity(UC btemp);
void out_z80(void);
void in_z80(void);
#endif
/*
#define ora(bval) \
	af.B.h|=bval; \
	af.B.l=(af.B.h&232)|parity[af.B.h]; \
	if(!af.B.h) SET_ZF; else RES_ZF;

#define xora(bval) \
	af.B.h^=bval; \
	af.B.l=(af.B.h&232)|parity[af.B.h];  \
	if(!af.B.h) SET_ZF; else RES_ZF;

#define anda(bval) \
	af.B.h&=bval;\
	af.B.l=16|(af.B.h&232)|parity[af.B.h]; \
	if(!af.B.h) SET_ZF; else RES_ZF;
*/
/*
extern void oraa(long bval);

#pragma aux oraa=\
"or byte ptr [af+1],al"\
"lahf"\
"and ah,196"\
"mov byte ptr [af],ah"\
parm [al]\
modify [ah];

#define ora(bval) oraa(bval);

extern void xoraa(long bval);

#pragma aux xoraa=\
"xor byte ptr [af+1],al"\
"lahf"\
"and ah,196"\
"mov byte ptr [af],ah"\
parm [al]\
modify [ah];

#define xora(bval) xoraa(bval);

extern void andaa(long bval);

#pragma aux andaa=\
"and byte ptr [af+1],al"\
"lahf"\
"and ah,196"\
"or ah,16"\
"mov byte ptr [af],ah"\
parm [al]\
modify [ah];

#define anda(bval) andaa(bval);
*/


#define ora(bval) \
	af.B.h|=bval; \
	af.B.l=ora_table[af.B.h];

#define xora(bval) \
	af.B.h^=bval; \
	af.B.l=xora_table[af.B.h];

#define anda(bval) \
	af.B.h&=bval; \
	af.B.l=anda_table[af.B.h];


/**************************/
/*
extern void ACT_RLCa(UC *reg);

#pragma aux ACT_RLCa=\
"rol byte ptr [eax],1"\
"mov ah, byte ptr [eax]"\
"setc al"\
"or ah,ah"\
"lahf"\
"and ah,236"\
"or ah,al"\
"mov byte ptr [af], ah"\
parm [eax]\
modify [ax];

#define ACT_RLC(reg) \
	ACT_RLCa(&reg); \
	t_add(8);
*/

#define ACT_RLC(reg) \
	af.B.l=rlcr_f[reg]; \
	reg=(reg<<1)|(reg>>7); \
	t_add(8);


#define CALC_RLC(reg) ((reg<<1)|(reg>>7))

/*
#define ACT_RLC(reg) \
	af.B.l=rlcr_f[reg]; \
	reg=rlcr_a[reg]; \
	t_add(8);

#define CALC_RLC(reg) rlcr_a[reg]
*/
/*
extern void ACT_RRCa(UC *reg);

#pragma aux ACT_RRCa=\
"ror byte ptr [eax],1"\
"mov ah, byte ptr [eax]"\
"setc al"\
"or ah,ah"\
"lahf"\
"and ah,236"\
"or ah,al"\
"mov byte ptr [af], ah"\
parm [eax]\
modify [ax];

#define ACT_RRC(reg) \
	ACT_RRCa(&reg); \
	t_add(8);
*/

#define ACT_RRC(reg) \
	af.B.l=rrcr_f[reg]; \
	reg=(reg>>1)|(reg<<7); \
	t_add(8);


#define CALC_RRC(reg) ((reg>>1)|(reg<<7))

/*
#define ACT_RRC(reg) \
	af.B.l=rrcr_f[reg]; \
	reg=rrcr_a[reg]; \
	t_add(8);

#define CALC_RRC(reg) rrcr_a[btemp]
*/

/*
extern void ACT_RLa(UC *reg);

#pragma aux ACT_RLa=\
"mov ah, byte ptr [af]"\
"sahf"\
"rcl byte ptr [ebx],1"\
"mov al, byte ptr [ebx]"\
"setc bl"\
"or al,al"\
"lahf"\
"and ah,236"\
"or ah,bl"\
"mov byte ptr [af], ah"\
parm [ebx]\
modify [ax bl];

#define ACT_RL(reg) \
	ACT_RLa(&reg); \
	t_add(8);
*/

#define ACT_RL(reg) \
	if(!(af.B.l&1)) \
	{ \
		af.B.l=rlr_f0[reg]; \
		reg<<=1; \
	} \
	else \
	{ \
		af.B.l=rlr_f1[reg]; \
		reg=(reg<<1)|1; \
	} \
	t_add(8);

#define CALC_RL0(reg) (reg<<1)
#define CALC_RL1(reg) ((reg<<1)|1)

/*
#define ACT_RL(reg) \
	if(!(af.B.l&1)) \
	{ \
		af.B.l=rlr_f0[reg]; \
		reg=rlr_a0[reg]; \
	} \
	else \
	{ \
		af.B.l=rlr_f1[reg]; \
		reg=rlr_a1[reg]; \
	} \
	t_add(8);

#define CALC_RL0(reg) rlr_a0[reg]
#define CALC_RL1(reg) rlr_a1[reg]
*/

/*
extern void ACT_RRa(UC *reg);

#pragma aux ACT_RRa=\
"mov ah, byte ptr [af]"\
"sahf"\
"rcr byte ptr [ebx],1"\
"mov al, byte ptr [ebx]"\
"setc bl"\
"or al,al"\
"lahf"\
"and ah,236"\
"or ah,bl"\
"mov byte ptr [af], ah"\
parm [ebx]\
modify [ax bl];

#define ACT_RR(reg) \
	ACT_RRa(&reg); \
	t_add(8);
*/

#define ACT_RR(reg) \
	if(!(af.B.l&1)) \
	{ \
		af.B.l=rrr_f0[reg]; \
		reg>>=1; \
	} \
	else \
	{ \
		af.B.l=rrr_f1[reg]; \
		reg=(reg>>1)|128; \
	} \
	t_add(8);

#define CALC_RR0(reg) (reg>>1)
#define CALC_RR1(reg) ((reg>>1)|128)

/*
#define ACT_RR(reg) \
	if(!(af.B.l&1)) \
	{ \
		af.B.l=rrr_f0[reg]; \
		reg=rrr_a0[reg]; \
	} \
	else \
	{ \
		af.B.l=rrr_f1[reg]; \
		reg=rrr_a1[reg]; \
	} \
	t_add(8);

#define CALC_RR0(reg) rrr_a0[reg]
#define CALC_RR1(reg) rrr_a1[reg]
*/

/*
extern ACT_SLAa(UC *reg);

#pragma aux ACT_SLAa= \
"sal byte ptr [eax],1"\
"lahf"\
"and ah,237"\
"mov byte ptr [af], ah"\
parm [eax]\
modify [eax];

#define ACT_SLA(reg) \
	ACT_SLAa(&reg); \
	t_add(8);

*/

#define ACT_SLA(reg) \
	af.B.l=sla_f[reg]; \
	reg<<=1; \
	t_add(8);


#define CALC_SLA(reg) (reg<<1)

/*
#define ACT_SLA(reg) \
	af.B.l=sla_f[reg]; \
	reg=sla_a[reg]; \
	t_add(8);

#define CALC_SLA(reg) sla_a[reg]
*/

/*
extern ACT_SRAa(UC *reg);

#pragma aux ACT_SRAa= \
"sar byte ptr [eax],1"\
"lahf"\
"and ah,237"\
"mov byte ptr [af], ah"\
parm [eax]\
modify [eax];

#define ACT_SRA(reg) \
	ACT_SRAa(&reg); \
	t_add(8);
*/

#define ACT_SRA(reg) \
	af.B.l=sra_f[reg]; \
	reg=(reg>>1)|(reg&128); \
	t_add(8);

#define CALC_SRA(reg) ((reg>>1)|(reg&128))

/*
#define ACT_SRA(reg) \
	af.B.l=sra_f[reg]; \
	reg=sra_a[reg]; \
	t_add(8);

#define CALC_SRA(reg) sra_a[reg]
*/

/*
extern ACT_SLLa(UC *reg);

#pragma aux ACT_SLLa= \
"shl byte ptr [eax],1"\
"lahf"\
"and ah,237"\
"mov byte ptr [af], ah"\
"or byte ptr [eax],1"\
parm [eax]\
modify [eax];

#define ACT_SLL(reg) \
	ACT_SLLa(&reg); \
	t_add(8);
*/

#define ACT_SLL(reg) \
	af.B.l=sll_f[reg]; \
	reg=(reg<<1)|1; \
	t_add(8);


#define CALC_SLL(reg) ((reg<<1)|1)

/*
#define ACT_SLL(reg) \
	af.B.l=sll_f[reg]; \
	reg=sll_a[reg]; \
	t_add(8);

#define CALC_SLL(reg) sll_a[reg]
*/

/*
extern ACT_SRLa(UC *reg);

#pragma aux ACT_SRLa= \
"shr byte ptr [eax],1"\
"lahf"\
"and ah,237"\
"mov byte ptr [af], ah"\
parm [eax]\
modify [eax];

#define ACT_SRL(reg) \
	ACT_SRLa(&reg); \
	t_add(8);
*/

#define ACT_SRL(reg) \
	af.B.l=srl_f[reg]; \
	reg>>=1; \
	t_add(8);

#define CALC_SRL(reg) (reg>>1)

/*
#define ACT_SRL(reg) \
	af.B.l=srl_f[reg]; \
	reg=srl_a[reg]; \
	t_add(8);

#define CALC_SRL(reg) srl_a[reg]
*/

/**************************/
#ifdef MAIN_OBJ
void grab_mem(void)
{
	UC x;

	for(x=0;x<2;x++)
	{
		if(!(BRAM[x]=(UC *)malloc(0x4000)))
		{
		      printf("BRAM %d Arg!\n",x);
		      quit=QUIT_COMPLETELY;
		}
		else
		{
		      memset(BRAM[x],0,0x4000);
		}
	}
	if(!(RAM_C000=(UC *)malloc(0x2000)))
	{
	      printf("RAM_C000 %d Arg!\n",x);
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(RAM_C000,0,0x2000);
	}
	if(!(DUMMY_MEM=(UC *)malloc(0x2000)))
	{
	      printf("DUMMY_MEM Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(DUMMY_MEM,0,0x2000);
	}
	/*if(!(VIDEO=(UC *)malloc(0x10000)))
	{
	      printf("VIDEO Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(VIDEO,0,0x10000);
	}*/
	if(!(VRAM=(UC *)malloc(0x4000)))
	{
	      printf("VRAM Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(VRAM,0,0x4000);
	}
	if(!(VPAL=(UC *)malloc(0x40)))
	{
	      printf("VPAL Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(VRAM,0,0x40);
	}
	if(!(CSET=(UC *)malloc(0x4000)))
	{
	      printf("CSET Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(CSET,0,0x4000);
	}
	if(!(BUFFER=(UC *)malloc(0x40)))
	{
	      printf("BUFFER Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(BUFFER,0,0x40);
	}
	if(!(TL_BUF=(UC *)malloc(0x300)))
	{
	      printf("Line Buffer Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(TL_BUF,0,0x300);
	      L_BUF=TL_BUF+0x100;
	}
	if(!(TL_BUF2=(UC *)malloc(0x300)))
	{
	      printf("Line Buffer Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(TL_BUF2,0,0x300);
	      L_BUF2=TL_BUF2+0x100;
	}
	if(!(TL_BUF3=(UC *)malloc(0x300)))
	{
	      printf("Line Buffer Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(TL_BUF3,0,0x300);
	      L_BUF3=TL_BUF3+0x100;
	}
	if(!(TDL_BUF=(UC *)malloc(0x300)))
	{
	      printf("Line Buffer Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(TDL_BUF,0,0x300);
	      DL_BUF=TDL_BUF+0x100;
	}
	if(!(DL_BUF3=(UC *)malloc(0x100)))
	{
	      printf("Line Buffer Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(DL_BUF3,0,0x100);
	}

#ifdef MSDOS_SYSTEM
#ifndef NO_BUFFER
	if(!(XBuf=(UC *)malloc(61440)))
	{
	      printf("XBuf Arg!\n");
	      quit=QUIT_COMPLETELY;
	}
	else
	{
	      memset(XBuf,0,61440);
	}
#endif
#endif
}

void grab_cart_mem(word no_of_16k_pages)
{
	UC no_of_ram_pages;
	word x;
	long temp_long;

	if(!no_of_16k_pages) return;
	cart_in_mem=1;
	memset(RAM_C000,0,0x2000);
	memset(VRAM,0,0x4000);
	memset(VPAL,0,0x40);

	if(!(s_handle = fopen(the_sav_path,"rb")))
	{
		/* Couldn't open SAV file */
		memset(BRAM[0],0,0x4000);
		memset(BRAM[1],0,0x4000);
	}
	else
	{
		fseek(s_handle,0,SEEK_END);
		temp_long=ftell(s_handle);
		fseek(s_handle,0,SEEK_SET);
		no_of_ram_pages=temp_long/16384;
		if((temp_long-(no_of_ram_pages*16384)))
		{
			printf("SAV file not a multiple of 16K\n");
			quit=QUIT_COMPLETELY;
		}
		else
		{
			for(x=0;x<no_of_ram_pages;x++)
			{
				fread(BRAM[x],1,16384,s_handle);
			}
		}
		fclose(s_handle);
	}
	/*printf("No of rom pages : %d\n",no_of_16k_pages);*/
	for(x=0;x<no_of_16k_pages;x++)
	{
		if(!(ROM[x]=(UC *)malloc(0x4000)))
		{
		      printf("Cart ROM %d Arg!\n",x);
		      quit=QUIT_COMPLETELY;
		}
		else
		{
		      fread(ROM[x],1,0x4000,handle);
		}
	}
	SRAMR[0]=ROM[0];SRAMR[1]=SRAMR[0]+8192;
	SRAMW[0]=SRAMW[1]=DUMMY_MEM;

	SRAMR[2]=ROM[1];SRAMR[3]=SRAMR[2]+8192;
	SRAMW[2]=SRAMW[3]=DUMMY_MEM;
	RAM_C000[8190]=1;

	SRAMR[4]=ROM[0];SRAMR[5]=SRAMR[0]+8192; /* Not sure at all */
	SRAMW[4]=SRAMW[5]=DUMMY_MEM;
	RAM_C000[8191]=0;

	SRAMW[6]=SRAMR[6]=RAM_C000;

	SRAMR[7]=SRAMR[6]; /*ROM[0];*/ /* Not sure again */
	SRAMW[7]=SRAMW[6]; /*DUMMY_MEM;*/
}

void release_mem(void)
{
	UC x;

	for(x=0;x<2;x++)
	{
		free(BRAM[x]);
	}
	free(RAM_C000);
	/*free(VIDEO);*/
	free(VRAM);
	free(VPAL);
	free(CSET);
	free(BUFFER);
	free(TL_BUF);
	free(TL_BUF2);
	free(TL_BUF3);
	free(TDL_BUF);
	free(DL_BUF3);
#ifdef MSDOS_SYSTEM
#ifndef NO_BUFFER
	free(XBuf);
#endif
#endif
	free(DUMMY_MEM);
}

void release_cart_mem(word no_of_16k_pages)
{
	UC page_in_use, highest_page_used;
	word x, xx;

	if(!cart_in_mem) return;
	for(x=0;x<no_of_16k_pages;x++)
	{
		free(ROM[x]);
	}
	cart_in_mem=0;

	/* Find which pages are to be written */
	highest_page_used=0;
	for(x=0;x<2;x++)
	{
		xx=page_in_use=0;
		while((xx<16384)&&(!page_in_use))
		{
			if(BRAM[x][xx])
			{
				page_in_use=1;
				highest_page_used=x+1;
			}
			xx++;
		}
	}
	if(highest_page_used)
	{
		if(!(s_handle = fopen(the_sav_path,"wb")))
		{
			perror("Error:");
			printf("Can't create Save File : %s\n",the_sav_path);
		}
		else
		{
			for(x=0;x<highest_page_used;x++)
			{
				fwrite(BRAM[x],1,16384,s_handle);
			}
			fclose(s_handle);
		}
	}
}

void clean_regs(void)
{
	UC x;

	/* Soundchip reset? */
	for(x=0;x<8;x++) PSG[x]=0xFFFF;

	iff1=iff2=bit7_r=0;
	hl.W=de.W=bc.W=0;
	hl2.W=de2.W=de2.W=0;
	ix.W=iy.W=0;
	im=1;
	ir.W=sp.W=pc.W=0;
	af.W=af2.W=halt=ROM_pager=0;
	vline=t_state=0;
	ROM_4000=1;BRAM_page=0;
	first_191=first_127=0;
	waiting_191=waiting_127=0;
	if(gg_mode)
	{
		for(x=0;x<32;x++) host_pal[x]=0;
		pal0=(char *)(host_pal);
		pal1=(char *)(host_pal+16);
		port220=255/*63*/;
	}
	else
	{
		pal0=VPAL;
		pal1=VPAL+0x10;
		port220=255;
	}
	spr_tile_addr=VRAM;
	tile_addr=VRAM;
	scr_map_addr=VRAM+0x3800;
	sprite_y=VRAM+0x3F00;
	sprite_x=VRAM+0x3F80;


	vreg128=0; vreg129=0; vreg130=0; vreg131=0;
	vreg132=0; vreg133=0; vreg134=0; vreg135=0;
	vreg138=255; x_scroll=0; y_scroll=0;
	next_int_line=311;spr_point=0;
	port0=255; port63=255; port220=255; port221=31; port222=255;
	port242=255; rom_limit=0; line_int=0; port1=255;

	vdp_addr=0;vdp_and=0x3FFF;vdp_pal=0;VIDEO=VRAM;

	sprite_left=0;screen_on=0;left_clip=0;
	top_2_lock=0;right_8_lock=0;
}

#endif
