/*
** LCR.C   Communication Port Test Code
**
** Coded by : James P. Ketrenos
**
**      You have permission to use this if you want.  You are not required
**      to use it.  However, if it should cause harm to you, your computer,
**  your dog, or anyone/thing you know/have/own, I am not responsible.
**
**  By using this, or any file in this archive, you acknowledge that
**  fact and accept it.
**
*/
#define LCR_OBJ

#include <stdio.h>
/*#include <stdlib.h>
#include <conio.h>*/
#include "old_lcr.h"
#include "sms_end.c"
#include "ll_comm.h"
#include "ll_stat.h"

#define VER_ID  "0001.3000"

extern unsigned char send_port1, send_port3, read_port4;
extern unsigned char port1, port2, port3, port4, port5;
extern unsigned char quit;

char connect_number[50];
#ifdef PACKETS
char r_packet[512], w_packet[512];
word r_packet_len, w_packet_len=0;
#endif
int use_modem=0, null_modem=0;
int gg_connect=0;
unsigned char external_hblank_sync=0, hblank_confirm=0;
unsigned char request_talk=0;

extern void RePaintScreen(void);
extern void scr_write_letter(UC x, UC y, UC attr, UC letter);
extern void setup_talk_window(void);
extern void undo_talk_window(void);
extern void quit_window(void);

int     COM_BASE=0x3F8/*0x2F8*/;
int     COM_IRQ=4/*3*/;
int     COM_RATE=14400;
int     COM_SET=(BITS_8 | STOP_1 | NO_PARITY);
int     COM_FIFO=0;
COMM    Port;

int     ECHO=0;
int     LF=0;
int     xpos,ypos=0;
char    *t_screen=(char *)0x000b8000;

WriteStr(COMM Port, char        *str)
{
	for (; *str; str++)
		ioWriteByte(Port, *str);
}

void write_gg(unsigned char first, unsigned char second)
{
	while(!ioWriteByte(Port,first));
	while(!ioWriteByte(Port,second));
}

void write_single_gg(unsigned char first)
{
	while(!ioWriteByte(Port,first));
}

void set_baud(long baud_rate)
{
	COM_RATE=baud_rate;
}

void set_port(char *port_str)
{
	sscanf(port_str,"%x",&COM_BASE);
}

void set_irq(int irq_num)
{
	COM_IRQ=irq_num;
}

void set_com(int com_number)
{
	switch(com_number)
	{
		case 1:
			COM_BASE=0x3F8;
			COM_IRQ=4;
			break;
		case 2:
			COM_BASE=0x2F8;
			COM_IRQ=3;
			break;
		case 3:
			COM_BASE=0x3E8;
			COM_IRQ=4;
			break;
		case 4:
			COM_BASE=0x2E8;
			COM_IRQ=3;
			break;
		default:
			printf("Bad COM number\n");
			break;
	}
}

void set_dial(char *phone_no)
{
	char temp_str[50];

	use_modem=1;
	strcpy(temp_str,"ATDT");
	strcat(temp_str,phone_no);
	strcat(temp_str,"\r");
	strcpy(connect_number,temp_str);
}

void set_auto_answer(void)
{
	use_modem=2;
	strcpy(connect_number,"ATS0=1\r");
}

void set_null_modem(void)
{
	null_modem=1;
}

void close_modem(void)
{
	if(use_modem)
	{
		ioClosePort(Port);
	}
}

unsigned char modem_startup(void)
{
	unsigned char code_got;
	unsigned char exit_state;
	char ok[3];

	printf("Initializing Modem . . .\n\r");

	WriteStr(Port,"ATZ\r");
	ok[0]='O';
	ok[1]='K';
	printf("Waiting for OK... <ESC> aborts\n");
	exit_state=code_got=0;
	while(!exit_state)
	{
		if(kbhit())
		{
			if(getch()==27) exit_state=1;
		}
		if(ioReadStatus(Port))
		{
			if(ok[code_got]==ioReadByte(Port))
			{
				code_got++;
			}
			else
			{
				code_got=0;
			}
			if(code_got==2)
			{
				exit_state=2;
			}
		}
	}
	if(exit_state==1) /* Aborted */
	{
		gg_connect=0;
		close_modem();
		use_modem=0;
		port5=4;
		return 0;
	}

	WriteStr(Port,"ATM\r");
	ok[0]='O';
	ok[1]='K';
	printf("Waiting for OK... <ESC> aborts\n");
	exit_state=code_got=0;
	while(!exit_state)
	{
		if(kbhit())
		{
			if(getch()==27) exit_state=1;
		}
		if(ioReadStatus(Port))
		{
			if(ok[code_got]==ioReadByte(Port))
			{
				code_got++;
			}
			else
			{
				code_got=0;
			}
			if(code_got==2)
			{
				exit_state=2;
			}
		}
	}
	if(exit_state==1) /* Aborted */
	{
		gg_connect=0;
		close_modem();
		use_modem=0;
		port5=4;
		return 0;
	}

	printf("%s\n",connect_number);
	WriteStr(Port,connect_number);
	return 1;
}

unsigned char modem_endup(void)
{
	unsigned char code_got;
	unsigned char exit_state;
	char connect[8];

	printf("Waiting for CONNECT... <ESC> aborts\n");
	exit_state=code_got=0;
	strcpy(connect,"CONNECT");
	while(!exit_state)
	{
		if(kbhit())
		{
			if(getch()==27) exit_state=1;
		}
		if(ioReadStatus(Port))
		{
			if(connect[code_got]==ioReadByte(Port))
			{
				code_got++;
			}
			else
			{
				code_got=0;
			}
			if(code_got==7)
			{
				exit_state=2;
			}
		}
	}
	return exit_state;
}

void open_modem(void)
{
	unsigned char code_got;
	unsigned char exit_state;
	char sync_code[5];

	if(use_modem)
	{
		Port=ioOpenPort(COM_BASE, COM_IRQ);
		if(!Port)
		{
			use_modem=gg_connect=0;
			return;
		}
		ioSetBaud(Port, COM_RATE);
		ioSetHandShake(Port, DTR | RTS);
		ioSetControl(Port, COM_SET);
		ioSetMode(Port, BYTE_MODE);

		gg_connect=1;

		if(!null_modem)
		{
			if(!modem_startup()) return;
		}
		port5&=251;
		sync_code[0]=0xFF;
		sync_code[1]=0xFE;
		if(use_modem==1) /* sender */
		{
			printf("Waiting for sync... <ESC> aborts\n");
			exit_state=code_got=0;
			while(!exit_state)
			{
				if(kbhit())
				{
					if(getch()==27) exit_state=1;
				}
				if(ioReadStatus(Port))
				{
					if(sync_code[code_got]==ioReadByte(Port))
					{
						code_got++;
					}
					else
					{
						code_got=0;
					}
					if(code_got==2)
					{
						exit_state=2;
					}
				}
			}
			if(exit_state==1) /* Aborted */
			{
				gg_connect=0;
				close_modem();
				use_modem=0;
				port5=4;
			}
		}
		else
		{
			if(!null_modem)
			{
				exit_state=modem_endup();
			}
			else
			{
				exit_state=2;
			}

			if(exit_state==1) /* Aborted */
			{
				gg_connect=0;
				close_modem();
				use_modem=0;
				port5=4;
			}
			else
			{
				printf("Writing Sync...\n");
				ioWriteByte(Port,sync_code[0]);
				ioWriteByte(Port,sync_code[1]);
			}
		}
	}
}

#ifdef PACKETS
void write_packet(void)
{
	word x;

	/* Send start of packet (0xFA) */
	write_single_gg(0xFA);

	/* Send length of packet */
	write_single_gg(w_packet_len&0xFF);
	write_single_gg(w_packet_len>>8);

	/* Send length of packet AGAIN! */
	write_single_gg(w_packet_len&0xFF);
	write_single_gg(w_packet_len>>8);

	/* Send packet */
	for(x=0;x<w_packet_len;x++)
	{
		write_single_gg(w_packet[x]);
	}

	/* Send end mark (0xF9) */
	write_single_gg(0xF9);
}

UC read_packet(void)
{
	word length, length2, x;
	UC done;

	/* Find start of packet (0xFA) */
	while(!done)
	{
		if(ioReadStatus(Port))
		{
			switch(ioReadByte(Port))
			{
				case 0xFA:
					done=1;
					break;
				case 0xF9:
					break;
				default:
					printf("bad byte at start of packet\n");
					return 0;
			}
		}
	}
	/* Get length of packet */
	length=x=0;
	while(x<2)
	{
		if(ioReadStatus(Port))
		{
			length|=(ioReadByte(Port)<<(8*x));
			x++;
		}
	}
	/* Get length again!  In case the first was wrong! */
	length2=x=0;
	while(x<2)
	{
		if(ioReadStatus(Port))
		{
			length2|=(ioReadByte(Port)<<(8*x));
			x++;
		}
	}
	if(length!=length2)
	{
		printf("Lengths don't compare!\n");
		return 0;
	}
	/* Get packet */
	r_packet_len=length;
	x=0;
	while(x<length)
	{
		if(ioReadStatus(Port))
		{
			r_packet[x++]=ioReadByte(Port);
		}
	}
	/* Get end mark (0xF9) */
	done=0;
	while(!done)
	{
		if(ioReadStatus(Port))
		{
			if(ioReadByte(Port)!=0xF9)
			{
				printf("Wrong end marker!\n");
				return 0;
			}
		}
	}
	return 1;
}

void parse_packet(void)
{
	static unsigned char waiting_next=0 ,temp1, temp2;

	while(ioPacketStatus())
	{
		temp1=ioReadPacket();
		if(!(temp1&128))
		{
			/* nuffin */;
		}
		else
		{
			switch(temp1)
			{
				case 0x81:
					temp2=ioReadPacket();

					port1=((temp2&3)<<2)|
					      ((temp2&12)>>2)|
					      ((temp2&16)<<1)|
					      ((temp2&32)>>1)|
					      (temp2&64)|128;
					port1&=port2;
					port5|=2;
					break;
				case 0x83:
					temp2=ioReadPacket();

					port4=temp2;
					port5|=2;
					if((port5&56)==56)
					{
						quit=QUIT_NMI;
					}
					break;
				case 0xFB:
					quit_window();
					gg_connect=0;
					port5=4;
					break;
				case 0xFC:
					hblank_confirm=1;
					break;
				case 0xFD:
					external_hblank_sync=1;
					break;
				case 0xFE:
					port5&=254;
					break;
				case 0xFF:
					quit=QUIT_TALK;
					request_talk=0;
					break;
				default:
					printf("Unknown block\n");
					break;
			}
		}
	}
	clear_r_packet();
	if(send_port1)
	{
		send_port1=0;
		write_p_gg(0x81,(port1&(~port2)));
		/*printf("port1 send : %d\n",(port1&(~port2)));*/
	}
	if(send_port3)
	{
		send_port3=0;
		write_p_gg(0x83,port3);
		/*printf("port3 send : %d\n",port3);*/
	}
	if(read_port4)
	{
		read_port4=0;
		write_p_single_gg(0xFE);
		/*printf("FE 00 sent\n");*/
	}
}
#endif

void check_modem(void)
{
	static unsigned char waiting_next=0 ,temp1, temp2;

	if(ioReadStatus(Port)/*>=2*/)
	{
		temp1=ioReadByte(Port);
		if(!(temp1&128))
		{
			/* nuffin */;
		}
		else
		{
			switch(temp1)
			{
				case 0x81:
					while(!ioReadStatus(Port));
					temp2=ioReadByte(Port);

					port1=((temp2&3)<<2)|
					      ((temp2&12)>>2)|
					      ((temp2&16)<<1)|
					      ((temp2&32)>>1)|
					      (temp2&64)|128;
					port1&=port2;
					port5|=2;
					break;
				case 0x83:
					while(!ioReadStatus(Port));
					temp2=ioReadByte(Port);

					port4=temp2;
					port5|=2;
					if((port5&56)==56)
					{
						quit=QUIT_NMI;
					}
					break;
				case 0xFB:
					quit_window();
					gg_connect=0;
					port5=4;
					break;
				case 0xFC:
					hblank_confirm=1;
					break;
				case 0xFD:
					external_hblank_sync=1;
					break;
				case 0xFE:
					port5&=254;
					break;
				case 0xFF:
					quit=QUIT_TALK;
					request_talk=0;
					break;
				default:
					printf("Unknown block\n");
					break;
			}
		}
	}
	if(send_port1)
	{
		send_port1=0;
		write_gg(0x81,(port1&(~port2)));
		/*printf("port1 send : %d\n",(port1&(~port2)));*/
	}
	if(send_port3)
	{
		send_port3=0;
		write_gg(0x83,port3);
		/*printf("port3 send : %d\n",port3);*/
	}
	if(read_port4)
	{
		read_port4=0;
		write_single_gg(0xFE);
		/*printf("FE 00 sent\n");*/
	}
}

void transmit_hblank(void)
{
	write_single_gg(0xFD);
	/*printf("hblank sent\n");*/
	hblank_confirm=0;
	while(!hblank_confirm)
	{
		check_modem();
		if((quit)&&(quit!=QUIT_NMI)) hblank_confirm=1;
	}
	/*printf("transmit_hblank : got confirmation\n");*/
}

void receive_hblank(void)
{
	/*printf("receive_hblank : waiting for hblank_sync\n");*/
	while(!external_hblank_sync)
	{
		check_modem();
		if((quit)&&(quit!=QUIT_NMI)) external_hblank_sync=1;
	}
	external_hblank_sync=0;
	write_single_gg(0xFC);
	/*printf("hblank confirmation sent\n");*/
}

void sync_connect(void)
{
	if(use_modem==1)
	{
		transmit_hblank();
	}
	else
	{
		receive_hblank();
	}
}

void request_talk_mode(void)
{
	if(request_talk)
	{
		request_talk=0;
		write_single_gg(0xFF);
	}
}

void talk_mode(void)
{
	UC x_me, y_me, x_other, y_other, exit_talk, temp_char;
	UC moved_me, moved_other;

	moved_me=moved_other=1;
	x_me=y_me=0;
	x_other=exit_talk=0;
	y_other=13;
	setup_talk_window();
	while(!exit_talk)
	{
		if(ioReadStatus(Port))
		{
			temp_char=ioReadByte(Port);
			if((temp_char>31)&&(temp_char<128))
			{
				/* print it in receive(lower) window */
				scr_write_letter(x_other,y_other,79,temp_char);
				if(++x_other==32)
				{
					x_other=0;
					if(++y_other==24) y_other=13;
					for(temp_char=0;temp_char<32;temp_char++)
					{
						scr_write_letter(temp_char,y_other,79,' ');
					}
				}
				moved_other=1;
			}
			if(temp_char=='\r')
			{
				scr_write_letter(x_other,y_other,79,' ');
				x_other=0;
				if(++y_other==24) y_other=13;
				for(temp_char=0;temp_char<32;temp_char++)
				{
					scr_write_letter(temp_char,y_other,79,' ');
				}
				moved_other=1;
			}
			if(temp_char==8)
			{
				scr_write_letter(x_other,y_other,79,' ');
				if(!x_other--)
				{
					x_other=31;
					if(y_other--==13)
					{
						y_other=13;
					}
				}
				moved_other=1;
			}
			if(temp_char==27)
			{
				/* begin exit */
				exit_talk=1;
			}
		}
		if(moved_other)
		{
			moved_other=0;
			scr_write_letter(x_other,y_other,121,' ');
			RePaintScreen();
		}
		if(kbhit())
		{
			temp_char=getch();
			ioWriteByte(Port,temp_char);
			if((temp_char>31)&&(temp_char<128))
			{
				/* print in own window */
				scr_write_letter(x_me,y_me,79,temp_char);
				if(++x_me==32)
				{
					x_me=0;
					if(++y_me==11) y_me=0;
					for(temp_char=0;temp_char<32;temp_char++)
					{
						scr_write_letter(temp_char,y_me,79,' ');
					}
				}
				moved_me=1;
			}
			if(temp_char=='\r')
			{
				scr_write_letter(x_me,y_me,79,' ');
				x_me=0;
				if(++y_me==11) y_me=0;
				for(temp_char=0;temp_char<32;temp_char++)
				{
					scr_write_letter(temp_char,y_me,79,' ');
				}
				moved_me=1;
			}
			if(temp_char==8)
			{
				scr_write_letter(x_me,y_me,79,' ');
				if(!x_me--)
				{
					x_me=31;
					if(y_me--==0)
					{
						y_me=0;
					}
				}
				moved_me=1;
			}
			if(temp_char==27)
			{
				/* begin exit */
				exit_talk=1;
			}
		}
		if(moved_me)
		{
			moved_me=0;
			scr_write_letter(x_me,y_me,121,' ');
			RePaintScreen();
		}
	}
	undo_talk_window();
}

void send_quit(void)
{
	write_single_gg(0xFB);
	WriteStr(Port,"+++\r");
	WriteStr(Port,"ATH\r");
}

