/******************************************/
/**                                      **/
/**           SMS_T PC C Version         **/
/**                                      **/
/**          (C) James McKay 1996        **/
/**                                      **/
/**    This software may not be used     **/
/**    for commercial reasons, the code  **/
/**    may not be modified or reused     **/
/**    without permission.               **/
/**                                      **/
/******************************************/
#define MAIN_OBJ
#define NO_BUFFER
/*#define NO_LOG*/
/*#define BREAKPOINT*/
#define LINE_INTERRUPT

#define SMS_SD 0
#define GG_SD 1
#define MONO_SD 2

void make_line_table(void);

/* The H flag in the adc16 and sbc16 is assumed to be bit 12 of result */

/* Non Portable Includes */
#include <dos.h>
#include <conio.h>

#ifndef __BORLANDC__
#include <i86.h>
#endif

/* Crucial!!!! */
#include "sms_end.c" /* Has LSB/MSB info. */

#include "sms_var.c"

#include "jdriver.c"

#include "sms_lcr.h"

/* Prototypes */
#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

#define CRTC_ADDR       0x3d4   /* Base port of the CRT Controller (color) */
#define SEQU_ADDR       0x3c4   /* Base port of the Sequencer */
#define GRAC_ADDR       0x3ce   /* Base port of the Graphics Controller */

#ifdef __BORLANDC__
void interrupt (*IRQ1Old)(__CPPARGS);
#else
void (__interrupt _far *IRQ1Old)();
#endif

#ifdef __BORLANDC__
void interrupt (*IRQtimeOld)(__CPPARGS);
#else
void (__interrupt _far *IRQtimeOld)();
#endif

void update_8bitline(register UC linenum);
void update_8bitline_gg(register UC linenum);
void update_monoline(register UC linenum);
void clean_regs(void);
void save_PSG(void);

/* Code */

/* Non Portable Vars and Defs */
#ifdef MSDOS_SYSTEM

#include "ti76489.h"

#else
void PSGOut(UC TI_1,UC TI_2)
{
	/*PSG[R]=V; erm... */
}
#endif

void Sound_on(void)
{
#ifdef OLD_NOISE
	if(all_sound_on)
	{
		ResumeSound();
	}
#endif
}

void Sound_off(void)
{
#ifdef OLD_NOISE
	MuteSound();
#endif
}

#ifndef NO_BUFFER
#define RefreshScreen() memcpy(SCREEN,XBuf,61440);
#endif

void RePaintScreen(void)
{
	UC y;

	if(bitpix==1)
	{
		for(y=0;y<192;y++) update_monoline(y);
	}
	else
	{
		for(y=0;y<192;y++) update_8bitline(y);
	}
#ifndef NO_BUFFER
	RefreshScreen();
#endif
}

void RePaintScreenGG(void)
{
	UC y;

	if(bitpix==1)
	{
		for(y=0;y<192;y++) update_monoline(y);
	}
	else
	{
		for(y=0;y<192;y++) update_8bitline_gg(y);
	}
#ifndef NO_BUFFER
	RefreshScreen();
#endif
}

#ifdef __BORLANDC__
UC *SCREEN = (UC *) MK_FP(0xA000,0); /* Very PC Specific! */
#else
UC *SCREEN = (UC *)0xA0000;
#endif

#ifndef NOT_TRYING_TIME_COMPENSATION

#ifdef __BORLANDC__
void interrupt IRQtimeHandler(__CPPARGS)
#else
void __interrupt IRQtimeHandler(void)
#endif
{
	time_taken++;
	outp(0x20,0x20);
}

#endif

/** A handler for the keyboard interrupt *********************/
#ifdef __BORLANDC__
void interrupt IRQ1Handler(__CPPARGS)
#else
void __interrupt IRQ1Handler(void)
#endif
{
  register UC Key, Key2;
  static UC c_shift=0; /* This is the host machines caps shift */
  static UC old_cs=0;

  _disable();
  Key=inp(0x60);
  Key2=Key&127;
  if(!(Key&128))
  {
	  switch(Key2)
	  {
		case 59: quit=QUIT_HELP;break;/* F1 */
		case 60: quit=QUIT_SCR_DUMP;break; /* F2 */
		case 61: quit=QUIT_PAR;break;  /* F3 */
		case 62: quit=QUIT_JOY;break; /* F4 */
		case 63: quit=QUIT_LOAD;break;/* F5 */
		case 64: quit=QUIT_SAVE_SNAP;break;/* F6 */
		case 65: quit=QUIT_LOAD_SNAP;break; /* F7 */
		case 66: quit=QUIT_EMUL_OPTIONS;break; /* F8 */
		case 67:
			if(++TOP_LINE==319) TOP_LINE=319;
			break;
		case 68: quit=QUIT_COMPLETELY;break;
		case 87: quit=QUIT_SOUND;break; /* F11 */
		case 88: quit=QUIT_TALK;request_talk=1;break; /*F12 */

		case  1: port221&=0xEF;break; /* Reset? Escape */
		case 29: port220&=0xDF;break; /* Button 1? Ctrl */
		case 56: port220&=0xEF;break; /* Button 2? Alt */
		case 57:
			if(gg_mode)
			{
				port0&=0x7F;
			}
			else
			{
				quit=QUIT_NMI; /* Space */
			}
			break;
		case 72: port220&=0xFE;break; /* Up */
		case 75: port220&=0xFB;break; /* Left */
		case 77: port220&=0xF7;break; /* Right */
		case 80: port220&=0xFD;break; /* Down */

		case 42: c_shift=1;break; /* Caps Shift */
	  }
  }
  else
  {
	switch(Key2)
	{
		case  1: port221|=0x10;break; /* Escape */
		case 29: port220|=0x20;break; /* Ctrl */
		case 56: port220|=0x10;break; /* Alt */
		case 57:
			if(gg_mode)
			{
				port0|=0x80;
			}
			break; /* Space */
		case 72: port220|=1;break; /* Up */
		case 75: port220|=4;break; /* Left */
		case 77: port220|=8;break; /* Right */
		case 80: port220|=2;break; /* Down */

		case 42: c_shift=0;break; /* Caps Shift */
	}
  }
  outp(0x20,0x20);
  _enable();
}

#define byte_swap(first,second) \
	btemp=first;first=second;second=btemp;

void joystick_calc(void)
{
	static UC next_time_or220=255;
	static UC next_time_or221=255;
	static UC next_time_or0=128;
	static UC let_go=1;
	UC btemp;

	if(!joy_present) return;
	port0|=next_time_or0;
	port220|=next_time_or220;
	port221|=next_time_or221;
	next_time_or220=0;
	next_time_or221=0;
	next_time_or0=0;
	poll_joystick();

	if(button_swap)
	{
		if(ggpad)
		{
			byte_swap(js_a_1,js_b_1);
			byte_swap(js_a_2,js_b_2);
		}
		else
		{
			byte_swap(js_a_1,js_a_2);
			byte_swap(js_b_1,js_b_2);
		}
	}

	if((!gg_mode)&&(joy1_is_p2))
	{
		if(js_a_x<left_A)
		{
			port221&=0xFE;
			next_time_or221|=1;
		}
		if(js_a_x>right_A)
		{
			port221&=0xFD;
			next_time_or221|=2;
		}
		if(js_a_y<up_A)
		{
			port220&=0xBF;
			next_time_or220|=0x40;
		}
		if(js_a_y>down_A)
		{
			port220&=0x7F;
			next_time_or220|=0x80;
		}
		if(ggpad)
		{
			if(!js_a_1)
			{
				port221&=0xFB;
				next_time_or221|=4;
			}
			if(!js_b_1)
			{
				port221&=0xF7;
				next_time_or221|=8;
			}
			if((js_a_2)&&(js_b_2)) let_go=1;
			if((let_go)&&((!js_a_2)||(!js_b_2)))
			{
				quit=QUIT_NMI;
				let_go=0;
			}
		}
		else
		{
			if(!js_a_1)
			{
				port221&=0xFB;
				next_time_or221|=4;
			}
			if(!js_a_2)
			{
				port221&=0xF7;
				next_time_or221|=8;
			}
		}
		return;
	}

	if(js_a_x<left_A)
	{
		port220&=0xFB;
		next_time_or220|=4;
	}
	if(js_a_x>right_A)
	{
		port220&=0xF7;
		next_time_or220|=8;
	}
	if(js_a_y<up_A)
	{
		port220&=0xFE;
		next_time_or220|=1;
	}
	if(js_a_y>down_A)
	{
		port220&=0xFD;
		next_time_or220|=2;
	}
	if(joy_present==2)
	{
		if(js_b_x<left_B)
		{
			port221&=0xFE;
			next_time_or221|=1;
		}
		if(js_b_x>right_B)
		{
			port221&=0xFD;
			next_time_or221|=2;
		}
		if(js_b_y<up_B)
		{
			port220&=0xBF;
			next_time_or220|=0x40;
		}
		if(js_b_y>down_B)
		{
			port220&=0x7F;
			next_time_or220|=0x80;
		}
	}
	if(ggpad)
	{
		if(!js_a_1)
		{
			port220&=0xEF;
			next_time_or220|=0x10;
		}
		if(!js_b_1)
		{
			port220&=0xDF;
			next_time_or220|=0x20;
		}
		if(gg_mode)
		{
			if((!js_a_2)||(!js_b_2))
			{
				port0&=0x7F;
				next_time_or0|=0x80;
			}
		}
		else
		{
			if((js_a_2)&&(js_b_2)) let_go=1;
			if((let_go)&&((!js_a_2)||(!js_b_2)))
			{
				quit=QUIT_NMI;
				let_go=0;
			}
		}

	}
	else
	{
		if(!js_a_1)
		{
			port220&=0xEF;
			next_time_or220|=0x10;
		}
		if(!js_a_2)
		{
			port220&=0xDF;
			next_time_or220|=0x20;
		}
		if(gg_mode)
		{
			if((!js_b_1)||(!js_b_2))
			{
				port0&=0x7F;
				next_time_or0|=0x80;
			}
		}
		else
		{
			if(!js_b_1)
			{
				port221&=0xFB;
				next_time_or221|=4;
			}
			if(!js_b_2)
			{
				port221&=0xF7;
				next_time_or221|=8;
			}
		}
	}
}

#ifndef NOT_TRYING_TIME_COMPENSATION
void init_timer(void)
{
	unsigned long IFreq, Cmp;

	IFreq=100; /* Set frequency to 100hz */
	Cmp=1193180L/IFreq;
	_disable();
	IRQtimeOld=_dos_getvect(0x08);
	outp(0x43,0x36);outp(0x40,Cmp&0xFF);outp(0x40,(Cmp>>8)&0xFF);
	_dos_setvect(0x08,IRQtimeHandler);
	_enable();
}

void release_timer(void)
{
	_disable();
	_dos_setvect(0x08,IRQtimeOld); /* Restore timer IRQ   */
	outp(0x43,0x36); /* Set timer */
	outp(0x40,0x00); /* back to */
	outp(0x40,0x00); /* 18.2Hz */
	_enable();
}
#endif

#ifdef __BORLANDC__
UC *TEXT = (UC *)MK_FP(0xB800,0); /* Very PC Specific! */
#else
UC *TEXT = (UC *)0xB8000;
#endif

void read_24_bit_pal(UC pal_num, UC *R, UC *G, UC *B)
{
	/*
	outp(0x3C8,pal_num);
	*R=(inp(0x3C9)<<2);
	*G=(inp(0x3C9)<<2);
	*B=(inp(0x3C9)<<2);
	*/
	if(pal_num<64)
	{
		*R=(pal_num&3)<<6; /* red */
		*G=((pal_num&12)>>2)<<6; /* green */
		*B=((pal_num&48)>>4)<<6; /* blue */
	}
	else
	{
		*R=0;
		*G=0;
		*B=0;
	}
}
#ifdef OLD_PAL
void set_pal_colour(register UC pal_num, register UC colour)
{
	outp(0x3C8,pal_num);
	outp(0x3C9,((colour&3)<<4)); /* red */
	outp(0x3C9,(((colour&12)>>2)<<4)); /* green */
	outp(0x3C9,(((colour&48)>>4)<<4)); /* blue */
}
#else
void set_pal_colour(register UC pal_num, register UC colour)
{
	UC R, G, B;

	R=colour&3;
	G=(colour&12)>>2;
	B=(colour&48)>>4;
	if(R) {R++;R<<=4;R--;}
	if(G) {G++;G<<=4;G--;}
	if(B) {B++;B<<=4;B--;}

	outp(0x3C8,pal_num);
	outp(0x3C9,R); /* red */
	outp(0x3C9,G); /* green */
	outp(0x3C9,B); /* blue */
}
#endif

void calc_gg_pal(register UC pal_num)
{
	UC btemp, btemp2, value;

	pal_num&=62;

	btemp=*(VPAL+pal_num);
	btemp2=*(VPAL+pal_num+1);

	value=((btemp&12)>>2)|((btemp&192)>>4)|((btemp2&12)<<2);
	host_pal[pal_num>>1]=value;
}

void init_screen(void)
{
	UC /*x,*/ mode;
	word x;
	union REGS R;

	mode=0x13;
	if(bitpix==1) mode=0x0D;
#ifdef __BORLANDC__
	R.x.ax=mode;
	int86(0x10,&R,&R);
#else
	R.w.ax=mode;
	int386(0x10,&R,&R);
#endif
	if(bitpix==8)
	{
		for(x=0;x<64;x++)
		{
			set_pal_colour(x,x);
			host_pal[x>>1]=0;
		}
	}
}

void release_screen(void)
{
	union REGS R;

#ifdef __BORLANDC__
	R.x.ax=0x03;
	int86(0x10,&R,&R);
#else
	R.w.ax=0x03;
	int386(0x10,&R,&R);
#endif
}

void init_keyboard(void)
{
	_disable();
	IRQ1Old=_dos_getvect(0x09);
	_dos_setvect(0x09,IRQ1Handler);
	_enable();
}

void release_keyboard(void)
{
	_disable();
	_dos_setvect(0x09,IRQ1Old); /* Restore keyboard */
	_enable();
}

#include "sms_def.c"

/* Very Non Portable FSL Stuff */

#define FNAME_SIZE 12 /* Length SHOWN on FSL */
#define UNIT_SIZE 20
#define FSL_WIN_WIDTH 20
#define FSL_WIN_START 6
#define FSL_BUFF UNIT_SIZE*2048

void get_dos_drives(void)
{
	UC drive_num;
	char temp[5];
	struct diskfree_t temp_t;

	strcpy(drives[1],"A:\\");
	strcpy(drives[2],"B:\\");
	for(drive_num=3;drive_num<27;drive_num++)
	{
		if(_dos_getdiskfree(drive_num,&temp_t)!=0)
		{
			drives[drive_num][0]='\0';
		}
		else
		{
			temp[0]=drive_num+'A'-1;
			temp[1]='\0';
			strcat(temp,":\\");
			strcpy(drives[drive_num],temp);
		}
	}
}

/* Port Read Keycodes For Input String */

#define X128_ESCAPE 1
#define X128_UP 72
#define X128_DOWN 80
#define X128_LEFT 75
#define X128_RIGHT 77
#define X128_RETURN 28
#define X128_PAGE_UP 73
#define X128_PAGE_DOWN 81
#define X128_KP_MINUS 74
#define X128_KP_PLUS 78
#define X128_HOME 71
#define X128_END 79
#define X128_INSERT 82
#define X128_DELETE 83
#define X128_BACKSPACE 14

UC fsl_asciiext_key(void)
{
	UC c;

	while(!kbhit());
	c=getch();
	if((c==27)||(c==13)||(c==8)) return inp(0x60);
	if(c)
	{
		return c;
	}
	else
	{
		getch();
		return inp(0x60);
	}
}

UC fsl_extend_key(void)
{
	while(!kbhit());
	if(!getch()) getch();
	return inp(0x60);
}

#ifdef __BORLANDC__
void far disk_err_handler(void)
#else
int __far disk_err_handler(unsigned deverr, unsigned errcode, unsigned far *devhdr)
#endif
{
	_hardresume(_HARDERR_IGNORE); /* Ignore */
#ifndef __BORLANDC__
	return _HARDERR_ABORT; /* Shouldn't get here */
#endif
}

#include "sms_fsl.c"
#include "sms_tap.c"
#include "sms_cb.h"
#include "sms_ed.h"
#include "sms_z80.h"
#include "sms_tbl.c"

void update_monoline(register UC linenum)
{
}

/*void update_8bitline(register UC linenum)
{
	register UC x, attr, data, *bitmap, *colmap;
	register  UC *R, *table_offset;

	bitmap=SP_SCREEN+spline[linenum];
	colmap=SP_SCREEN+(6144|((linenum>>3)<<5));
#ifdef NO_BUFFER
	R=SCREEN+(vga_x_y[linenum]);
#else
	R=(unsigned long *)(XBuf+(linenum*320));
#endif

	memset(R,border,32);
	R+=32;

	x=32;
	do
	{
		attr=(*colmap++)&flash_status;
		data=*bitmap++;
		table_offset=scr_table+(attr<<6);
		memcpy(R,table_offset+((data>>4)<<2),4);
		R+=4;
		memcpy(R,table_offset+((data&0x0F)<<2),4);
		R+=4;
	} while (--x);
	memset(R,border,32);
}*/

void update_8bitline(register UC linenum)
{
	register UC *R, *R2, *R3, *scr_map, *tile_pos, *tpos, *tpos2;
	register UC x, btemp;
	register word data, y_off;
	register UC x_co, y_co;
	register UC *x_map, *y_map;
	register unsigned long pal_or;
	pair tile;
	quadruple rtemp;
	/* Warning! rtemp must always be #def'd LSB */

	y_off=linenum+y_scroll;
	if(y_off>223) y_off-=224;
	tpos=tile_addr+((y_off&7)<<2);
	tpos2=tile_addr+(((7-y_off)&7)<<2);

	scr_map=scr_map_addr+((y_off>>3)<<6);

	R2=L_BUF;
	R3=L_BUF3;
	memset(R2,0,256);
	memset(R3,0,256);
	x=24;
	do
	{
		tile.B.l=*scr_map++;
		tile.B.h=*scr_map++;
		if(tile.B.h&16) R=R3; else R=R2;
		if(tile.B.h&8)
		{
			pal_or=0x10101010;
		}
		else
		{
			pal_or=0;
		}
		if(tile.B.h&4) /* Vertical flip */
		{
			tile_pos=tpos2+((tile.W&511)<<5);
		}
		else
		{
			tile_pos=tpos+((tile.W&511)<<5);
		}

		rtemp.Q=*(unsigned long *)tile_pos;
		if(tile.B.h&2) /* Horizontal flip */
		{
			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;
			R+=4;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R++=qtemp.B.b1;
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R=qtemp.B.b1;
		}
		else
		{
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)R=qtemp.Q;

			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)(R+4)=qtemp.Q;
		}
		R2+=8;R3+=8;
	} while (--x);

	if(vreg128&128) scr_map=scr_map_addr+((linenum>>3)<<6)+48;
	x=8;
	do
	{
		tile.B.l=*scr_map++;
		tile.B.h=*scr_map++;
		if(tile.B.h&16) R=R3; else R=R2;
		if(tile.B.h&8)
		{
			pal_or=0x10101010;
		}
		else
		{
			pal_or=0;
		}
		if(tile.B.h&4) /* Vertical flip */
		{
			tile_pos=tpos2+((tile.W&511)<<5);
		}
		else
		{
			tile_pos=tpos+((tile.W&511)<<5);
		}

		rtemp.Q=*(unsigned long *)tile_pos;
		if(tile.B.h&2) /* Horizontal flip */
		{
			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;
			R+=4;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R++=qtemp.B.b1;
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R=qtemp.B.b1;
		}
		else
		{
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)R=qtemp.Q;

			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)(R+4)=qtemp.Q;
		}
		R2+=8;R3+=8;
	} while (--x);

	/* Redo both tile buffers considering x scroll status. */
	if((vreg128&64)&&(!(linenum&0xF0))) /* top 2 lines of what? */
	{
		memcpy(DL_BUF,L_BUF,256);
		memcpy(DL_BUF3,L_BUF3,256);
	}
	else
	{
		memcpy(DL_BUF+x_scroll,L_BUF,256-x_scroll);
		memcpy(DL_BUF,L_BUF+(256-x_scroll),x_scroll);
		memcpy(DL_BUF3+x_scroll,L_BUF3,256-x_scroll);
		memcpy(DL_BUF3,L_BUF3+(256-x_scroll),x_scroll);
	}

	/* Now the sprites! */

	btemp=*(sprite_y+64);
	*(sprite_y+64)=208;
	y_map=sprite_y;
	for(x=255;(*y_map++!=208);x++);
	*(sprite_y+64)=btemp;
	y_map=sprite_y+x;
	x_map=sprite_x+((x<<1)|1);
	x++;

	if(vreg129&1)
	{
		while(x--)
		{
			y_co=(*y_map--)+1;
			if((UC)(y_co+16)>(UC)(linenum+16)) {x_map-=2;continue;}
			if((UC)(y_co+31/*15*/)<(UC)(linenum+16)) {x_map-=2;continue;}

			data=*x_map--;
			x_co=*x_map--;

			R=DL_BUF+x_co-(vreg128&8); /* left by 8 */
			tile_pos=(spr_tile_addr+(data<<5)+((((linenum-y_co)>>1)&7)<<2));
			rtemp.Q=*(unsigned long *)tile_pos;
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1];
			if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
			if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
			if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
			if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
			if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
			if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
			if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
			if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1];
			if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
			if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
			if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
			if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
			if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
			if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
			if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
			if(qtemp.B.b4) *R=qtemp.B.b4|16;
		}
	}
	else
	{
		if(vreg129&2)
		{
			while(x--)
			{
				y_co=(*y_map--)+1;
				if((UC)(y_co+16)>(UC)(linenum+16)) {x_map-=2;continue;}
				if((UC)(y_co+31/*15*/)<(UC)(linenum+16)) {x_map-=2;continue;}

				data=*x_map--;
				x_co=*x_map--;

				R=DL_BUF+x_co-(vreg128&8); /* left by 8? */
				if((linenum-y_co)&8)
				{
					tile_pos=(spr_tile_addr+((data+1)<<5)+(((linenum-y_co)&7)<<2));
				}
				else
				{
					tile_pos=(spr_tile_addr+(data<<5)+(((linenum-y_co)&7)<<2));
				}

				rtemp.Q=*(unsigned long *)tile_pos;

				qtemp.Q=msb_bspread3[rtemp.B.b4]|
					msb_bspread2[rtemp.B.b3]|
					msb_bspread1[rtemp.B.b2]|
					msb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
				qtemp.Q=lsb_bspread3[rtemp.B.b4]|
					lsb_bspread2[rtemp.B.b3]|
					lsb_bspread1[rtemp.B.b2]|
					lsb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R=qtemp.B.b4|16;
			}
		}
		else
		{
			while(x--)
			{
				y_co=(*y_map--)+1;
				if((UC)(y_co+16)>(UC)(linenum+16)) {x_map-=2;continue;}
				if((UC)(y_co+23/*7*/)<(UC)(linenum+16)) {x_map-=2;continue;}

				data=*x_map--;
				x_co=*x_map--;

				R=DL_BUF+x_co-(vreg128&8); /* left by 8 */
				tile_pos=(spr_tile_addr+(data<<5)+(((linenum-y_co)&7)<<2));

				rtemp.Q=*(unsigned long *)tile_pos;

				qtemp.Q=msb_bspread3[rtemp.B.b4]|
					msb_bspread2[rtemp.B.b3]|
					msb_bspread1[rtemp.B.b2]|
					msb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
				qtemp.Q=lsb_bspread3[rtemp.B.b4]|
					lsb_bspread2[rtemp.B.b3]|
					lsb_bspread1[rtemp.B.b2]|
					lsb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R=qtemp.B.b4|16;
			}
		}
	}

	data=256;
	R=DL_BUF;
	R3=DL_BUF3;
	while(data--)
	{
		btemp=*R3;
		if(btemp&15)
		{
			*R=*(pal0+btemp);
		}
		else
		{
			*R=*(pal0+*R); /* Back tile, or sprite */
		}
		R++;R3++;
	}

	if(vreg128&32) memset(DL_BUF,0,8); /* Left clipping */
	/* Maybe 0 should be border or paper colour? */

	R=SCREEN+vga_x_y[linenum];
	if(vreg129&64)
	{
		memcpy(R,DL_BUF,256); /* At last! */
	}
	else
	{
		memset(R,*(pal1+(vreg135&15)),256);/* border background? */
	}
}

/***************************************************************/

void update_8bitline_gg(register UC linenum)
{
	register UC *R, *R2, *R3, *scr_map, *tile_pos, *tpos, *tpos2;
	register UC x, btemp;
	register word data, y_off;
	register UC x_co, y_co;
	register UC *x_map, *y_map;
	register unsigned long pal_or;
	pair tile;
	quadruple rtemp;
	/* Warning! rtemp must always be #def'd LSB */

	if((linenum<24)||(linenum>167)) return;
	y_off=linenum+y_scroll;
	if(y_off>223) y_off-=224/*3*/;
	tpos=tile_addr+((y_off&7)<<2);
	tpos2=tile_addr+(((7-y_off)&7)<<2);

	scr_map=scr_map_addr+((y_off>>3)<<6);

	R2=L_BUF;
	R3=L_BUF3;
	memset(R2,0,256);
	memset(R3,0,256);
	x=24;
	do
	{
		tile.B.l=*scr_map++;
		tile.B.h=*scr_map++;

		if(tile.B.h&16) R=R3; else R=R2;
		if(tile.B.h&8)
		{
			pal_or=0x10101010;
		}
		else
		{
			pal_or=0;
		}
		if(tile.B.h&4) /* Vertical flip */
		{
			tile_pos=tpos2+((tile.W&511)<<5);
		}
		else
		{
			tile_pos=tpos+((tile.W&511)<<5);
		}
		rtemp.Q=*(unsigned long *)tile_pos;
		if(tile.B.h&2) /* Horizontal flip */
		{
			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;
			R+=4;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R++=qtemp.B.b1;
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R=qtemp.B.b1;
		}
		else
		{
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)R=qtemp.Q;

			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)(R+4)=qtemp.Q;
		}
		R2+=8;R3+=8;
	} while (--x);

	if(right_8_lock/*vreg128&128*/) scr_map=scr_map_addr+((linenum>>3)<<6)+48;
	x=8;
	do
	{
		tile.B.l=*scr_map++;
		tile.B.h=*scr_map++;
		if(tile.B.h&16) R=R3; else R=R2;
		if(tile.B.h&8)
		{
			pal_or=0x10101010;
		}
		else
		{
			pal_or=0;
		}
		if(tile.B.h&4) /* Vertical flip */
		{
			tile_pos=tpos2+((tile.W&511)<<5);
		}
		else
		{
			tile_pos=tpos+((tile.W&511)<<5);
		}

		rtemp.Q=*(unsigned long *)tile_pos;
		if(tile.B.h&2) /* Horizontal flip */
		{
			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;
			R+=4;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R++=qtemp.B.b1;
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			/**(unsigned long *)R=qtemp.Q;*/
			*R++=qtemp.B.b4;
			*R++=qtemp.B.b3;
			*R++=qtemp.B.b2;
			*R=qtemp.B.b1;
		}
		else
		{
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)R=qtemp.Q;

			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1]|
				pal_or;
			*(unsigned long *)(R+4)=qtemp.Q;
		}
		R2+=8;R3+=8;
	} while (--x);

	/* Redo both tile buffers considering x scroll status. */
	if((top_2_lock/*vreg128&64*/)&&(!(linenum&0xF0))) /* top 2 lines of what? */
	{
		memcpy(DL_BUF,L_BUF,256);
		memcpy(DL_BUF3,L_BUF3,256);
	}
	else
	{
		memcpy(DL_BUF+x_scroll,L_BUF,256-x_scroll);
		memcpy(DL_BUF,L_BUF+(256-x_scroll),x_scroll);
		memcpy(DL_BUF3+x_scroll,L_BUF3,256-x_scroll);
		memcpy(DL_BUF3,L_BUF3+(256-x_scroll),x_scroll);
	}

	/* Now the sprites! */

	btemp=*(sprite_y+64);
	*(sprite_y+64)=208;
	y_map=sprite_y;
	for(x=255;(*y_map++!=208);x++);
	*(sprite_y+64)=btemp;
	y_map=sprite_y+x;
	x_map=sprite_x+((x<<1)|1);
	x++;

	if(vreg129&1)
	{
		while(x--)
		{
			y_co=(*y_map--)+1;
			if(y_co>linenum) {x_map-=2;continue;}
			if((y_co+15)<linenum) {x_map-=2;continue;}
			data=*x_map--;
			x_co=*x_map--;

			R=DL_BUF+x_co-(sprite_left/*vreg128&8*/); /* left by 8 */
			tile_pos=(spr_tile_addr+(data<<5)+((((linenum-y_co)>>1)&7)<<2));
			rtemp.Q=*(unsigned long *)tile_pos;
			qtemp.Q=msb_bspread3[rtemp.B.b4]|
				msb_bspread2[rtemp.B.b3]|
				msb_bspread1[rtemp.B.b2]|
				msb_bspread0[rtemp.B.b1];
			if(qtemp.B.b1)
			{
				*R++=qtemp.B.b1|16;
				*R++=qtemp.B.b1|16;
			}
			else R+=2;
			if(qtemp.B.b2)
			{
				*R++=qtemp.B.b2|16;
				*R++=qtemp.B.b2|16;
			}
			else R+=2;
			if(qtemp.B.b3)
			{
				*R++=qtemp.B.b3|16;
				*R++=qtemp.B.b3|16;
			}
			else R+=2;
			if(qtemp.B.b4)
			{
				*R++=qtemp.B.b4|16;
				*R++=qtemp.B.b4|16;
			}
			else R+=2;
			qtemp.Q=lsb_bspread3[rtemp.B.b4]|
				lsb_bspread2[rtemp.B.b3]|
				lsb_bspread1[rtemp.B.b2]|
				lsb_bspread0[rtemp.B.b1];
			if(qtemp.B.b1)
			{
				*R++=qtemp.B.b1|16;
				*R++=qtemp.B.b1|16;
			}
			else R+=2;
			if(qtemp.B.b2)
			{
				*R++=qtemp.B.b2|16;
				*R++=qtemp.B.b2|16;
			}
			else R+=2;
			if(qtemp.B.b3)
			{
				*R++=qtemp.B.b3|16;
				*R++=qtemp.B.b3|16;
			}
			else R+=2;
			if(qtemp.B.b4)
			{
				*R++=qtemp.B.b4|16;
				*R++=qtemp.B.b4|16;
			}
		}
	}
	else
	{
		if(vreg129&2)
		{
			while(x--)
			{
				y_co=(*y_map--)+1;
				if(y_co>linenum) {x_map-=2;continue;}
				if((y_co+15)<linenum) {x_map-=2;continue;}
				data=*x_map--;
				x_co=*x_map--;

				R=DL_BUF+x_co-(sprite_left/*vreg128&8*/); /* left by 8? */
				if((linenum-y_co)&8)
				{
					tile_pos=(spr_tile_addr+((data+1)<<5)+(((linenum-y_co)&7)<<2));
				}
				else
				{
					tile_pos=(spr_tile_addr+(data<<5)+(((linenum-y_co)&7)<<2));
				}

				rtemp.Q=*(unsigned long *)tile_pos;

				qtemp.Q=msb_bspread3[rtemp.B.b4]|
					msb_bspread2[rtemp.B.b3]|
					msb_bspread1[rtemp.B.b2]|
					msb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
				qtemp.Q=lsb_bspread3[rtemp.B.b4]|
					lsb_bspread2[rtemp.B.b3]|
					lsb_bspread1[rtemp.B.b2]|
					lsb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R=qtemp.B.b4|16;
			}
		}
		else
		{
			while(x--)
			{
				y_co=(*y_map--)+1;
				if(y_co>linenum) {x_map-=2;continue;}
				if((y_co+7)<linenum) {x_map-=2;continue;}
				data=*x_map--;
				x_co=*x_map--;

				R=DL_BUF+x_co-(sprite_left/*vreg128&8*/); /* left by 8 */
				tile_pos=(spr_tile_addr+(data<<5)+(((linenum-y_co)&7)<<2));

				rtemp.Q=*(unsigned long *)tile_pos;

				qtemp.Q=msb_bspread3[rtemp.B.b4]|
					msb_bspread2[rtemp.B.b3]|
					msb_bspread1[rtemp.B.b2]|
					msb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R++=qtemp.B.b4|16; else R++;
				qtemp.Q=lsb_bspread3[rtemp.B.b4]|
					lsb_bspread2[rtemp.B.b3]|
					lsb_bspread1[rtemp.B.b2]|
					lsb_bspread0[rtemp.B.b1];
				if(qtemp.B.b1) *R++=qtemp.B.b1|16; else R++;
				if(qtemp.B.b2) *R++=qtemp.B.b2|16; else R++;
				if(qtemp.B.b3) *R++=qtemp.B.b3|16; else R++;
				if(qtemp.B.b4) *R=qtemp.B.b4|16;
			}
		}
	}

	data=160;
	R=DL_BUF+48;
	R3=DL_BUF3+48;
	while(data--)
	{
		btemp=*R3;
		if(btemp&15)
		{
			*R=*(pal0+btemp);
		}
		else
		{
			*R=*(pal0+*R); /* Back tile, or sprite */
		}
		R++;R3++;
	}
if(big_gg)
{
	R=SCREEN+vga_x_y[linenum]+8;
	if(screen_on/*vreg129&64*/)
	{
		R3=R;
		R2=DL_BUF+48;
		x=80;
		while(x--)
		{
			*(word *)R=*(word *)R2;
			R2+=2;
			R++;
			*R++=*R++;
		}
		if(!(linenum&3)) memcpy(R3+320,R3,240);
	}
	else
	{
		memset(R,*(pal1+(vreg135&15)),240);/* border background? */
		if(!(linenum&3)) memcpy(R+320,R,240);
	}
}
else
{
	R=SCREEN+vga_x_y[linenum]+48;
	if(screen_on/*vreg129&64*/)
	{
		memcpy(R,DL_BUF+48,160); /* At last! */
	}
	else
	{
		memset(R,*(pal1+(vreg135&15)),160);/* border background? */
	}
}

}

struct
{
	void (*driver)(register UC linenum);
} scr_mode[4]=
{
	update_8bitline,
	update_8bitline_gg,
	update_monoline,
	update_monoline
};

void unoptimisable_delay(void);

#pragma aux unoptimisable_delay=\
	"add dword ptr [qtemp],0"\
	"sub dword ptr [qtemp],0"\
	"add dword ptr [qtemp],0"\
	"sub dword ptr [qtemp],0";

void main_processor_decisions(void)
{
	static UC ff=0xFF;
	word wtemp1, wtemp2, wtemp3;

	t_state-=t_states_per_line;
	if(++vline==s_lines)
	{
		background_counter=vreg138+1;
		vline=0;
		if(vblank_optional)
		{
			if(vreg129&32) int_50=32;
		}
		else /* Don't allow too much drifting of vblank */
		{
			int_50=32;
		}
		joystick_calc();
		if(++screen_up==frame_skip)
		{
			screen_up=0;
		}
		if(slow_down)
		{
			for(wtemp1=0;wtemp1<slow_down;wtemp1++)
			{
				for(wtemp2=0;wtemp2<time_d;wtemp2++)
				{
					unoptimisable_delay();
				}
			}
		}
		if(test_speed)
		{
			if((++test_count)==10)
			{
				quit=QUIT_HELP;
			}
		}
		for(wtemp1=0;wtemp1<MAX_A_REPLAY;wtemp1++)
		{
			if(a_replay_on[wtemp1])
			{
				spokeb(a_replay_address[wtemp1],a_replay_poke[wtemp1]);
			}
		}
		if(PSG_open)
		{
			fwrite(&ff,1,1,p_handle);
		}
	}
	if(!LI_method)
	{
		/*if((vline>63)&&(line_int)) background_counter--;*/
		if((vline>63)&&(vline<TOP_LINE))
		{
			if(!--background_counter)
			{
				background_counter=vreg138+1;
				if(line_int) /* Maybe just int_50 in if? */
				{
					/*background_counter=vreg138+1;*/
					int_50=255;
					/*printf("vline=%d,iff1=%d\n",vline-64,iff1);*/
				}
			}
		}
	}
	else
	{
		if((vline==next_int_line))
		{
			if(line_int)
			{
			next_int_line+=vreg138+1;
			if(next_int_line>TOP_LINE) next_int_line=vreg138+64;
			int_50=255;
			}
		}
	}
	/*if(DSP_done)
	{
		process_PSG();
		DSP_done=0;
	}*/
	if(int_50)
	{
		int_50--;
		/*int_50=0;*/
		if(iff1)
		{
			int_50=0;
			iff2=iff1;
			iff1=halt=0;
			if(im==2)
			{
				qtemp.W.w1=(ir.B.h<<8)|255;
				push(pc.W);
				wordpeek(pc.W,qtemp.W.w1);
				INC_R_REG;
				t_state+=19;
			}
			else
			{
				INC_R_REG;
				/*rst_56();*/
				push(pc.W);
				pc.W=56;
				t_state+=13;
				/*t_state+=2;*/
			}
		}
	}
	if((!screen_up)&&(vline&192))
	{
		scr_mode[scr_driver].driver(vline-64);
	}
	if(gg_connect)
	{
		if(!(vline&7/*15*//*31*/))
		{
			SCREEN[0]++;
			sync_connect();
		}
	}
}
#define NO_ASM
#ifdef NO_ASM

#define main_bit \
  register UC byte; \
  \
  do \
  { \
	if(t_state>=t_states_per_line)  \
	{ \
		main_processor_decisions(); \
		if(quit) break; \
	} \
	INC_R_REG; \
	if(!halt) \
	{ \
		speekb(byte,pc.W); \
		pc.W++; \
		Z80[byte].opcode(); \
	} \
	else \
	{ \
		Z80[0].opcode(); \
	} \

#define main_bit_2 \
  }while(1);

void main_test_loop(void)
{
	main_bit;
	main_bit_2;
}
#else
extern void main_bit(void);

void main_test_loop(void)
{
	main_bit();
}
#endif

word processor_speed(UC passed_driver, UC passed_big_gg, UC passed_skip)
{
	word wtemp;
	UC old_frame_skip, old_big_gg, old_quit, old_gg_mode;
	UC *SRAMT[8];

	SRAMT[0]=SRAMR[0];SRAMT[1]=SRAMR[1];
	SRAMT[2]=SRAMR[2];SRAMT[3]=SRAMR[3];
	SRAMT[4]=SRAMR[4];SRAMT[5]=SRAMR[5];
	SRAMT[6]=SRAMR[6];SRAMT[7]=SRAMR[7];

	old_frame_skip=frame_skip;
	old_big_gg=big_gg;
	old_quit=quit;
	old_gg_mode=gg_mode;

	time_taken=test_count=0;
	test_speed=screen_on=1;
	big_gg=passed_big_gg;
	scr_driver=passed_driver;
	if(scr_driver==GG_SD)
	{
		gg_mode=1;
	}
	else
	{
		gg_mode=0;
	}
	make_line_table();
	frame_skip=passed_skip;
	if(frame_skip)
	{
		screen_up=0;
	}
	else
	{
		screen_up=1;
	}
	vreg129=32|64;
	halt=line_int=vline=t_state=0;
	for(wtemp=0;wtemp<4096;wtemp++)
	{
		DUMMY_MEM[wtemp<<1]=0;
		DUMMY_MEM[(wtemp<<1)+1]=128;
	}
	halt=1;
	SRAMR[0]=SRAMR[1]=SRAMR[2]=SRAMR[3]=DUMMY_MEM;
	SRAMR[4]=SRAMR[5]=SRAMR[6]=SRAMR[7]=DUMMY_MEM;
	quit=DONT_QUIT;
	init_timer();

	main_test_loop();

	release_timer();
	halt=0;
	quit=old_quit;
	test_speed=0;

	time_taken*=5;

	if(!time_taken)
	{
		printf("Infinitely fast machine!!!  Greater than 10000%%!!\n");
		return 1;
	}
	frame_skip=old_frame_skip;
	big_gg=old_big_gg;
	gg_mode=old_gg_mode;
	make_line_table();

	SRAMR[0]=SRAMT[0];SRAMR[1]=SRAMT[1];
	SRAMR[2]=SRAMT[2];SRAMR[3]=SRAMT[3];
	SRAMR[4]=SRAMT[4];SRAMR[5]=SRAMT[5];
	SRAMR[6]=SRAMT[6];SRAMR[7]=SRAMT[7];

	/*printf("Running at %d%% for /frame 0\n",10000/time_taken);*/
	return time_taken;
}

#ifdef OLD_DELAY
word delay_speed(void)
{
	unsigned long ltemp;
	word wtemp1, wtemp2, wtemp3;
	word time_x;

	time_x=128;
	while(time_x)
	{
		time_taken=0;
		slow_down=1;
		init_timer();
		for(ltemp=0;ltemp<150/*50*/;ltemp++)
		{
			for(wtemp1=0;wtemp1<slow_down;wtemp1++)
			{
				for(wtemp2=0;wtemp2<time_x;wtemp2++)
				{
					unoptimisable_delay();
				}
			}
		}
		release_timer();
		slow_down=0;
		if(time_taken>=3) /* Hopefully time_taken==1 */
		{
			time_x-=128;
			if(!time_x) time_x=1;
			printf("time_rough=%d\n",time_x);
			break;
		}
		else
		{
			time_x+=128;
			if(!time_x)
			{
				time_x-=128;
				printf("emer.time_rough=%d\n",time_x);
				break;
			}
		}
	}

	while(time_x)
	{
		time_taken=0;
		slow_down=1;
		init_timer();
		for(ltemp=0;ltemp<100/*50*/;ltemp++)
		{
			for(wtemp1=0;wtemp1<slow_down;wtemp1++)
			{
				for(wtemp2=0;wtemp2<time_x;wtemp2++)
				{
					unoptimisable_delay();
				}
			}
		}
		release_timer();
		slow_down=0;
		if(time_taken==2) /* Hopefully time_taken==1 */
		{
			printf("time_d=%d\n",time_x);
			return time_x;
		}
		time_x++;
	}
	printf("Too fast for a single delay tick!\n");
	return 0;
}
#else
word delay_speed(void)
{
	unsigned long ltemp, time_check;
	word wtemp1, wtemp2, wtemp3;
	word time_x, difference;
	UC going_down;

	going_down=0;
	time_check=2;
	while(1)
	{
		time_x=time_check-1;
		time_taken=0;
		slow_down=1;
		init_timer();
		for(ltemp=0;ltemp<150/*50*/;ltemp++)
		{
			for(wtemp1=0;wtemp1<slow_down;wtemp1++)
			{
				for(wtemp2=0;wtemp2<time_x;wtemp2++)
				{
					unoptimisable_delay();
				}
			}
		}
		release_timer();
		slow_down=0;
		if(time_taken<3)
		{
			if(!going_down)
			{
				time_check*=2;
				difference=time_check/2;
				if(time_check>65536)
				{
					printf("Too fast for delay!\n");
					return 0;
				}
			}
			else
			{
				time_check+=difference;
				difference/=2;
				if(!difference)
				{
					printf("time_d=%d\n",time_x);
					return time_x;
				}
			}
		}
		else
		{
			if(!difference)
			{
				printf("time_d=%d\n",time_x);
				return time_x;
			}
			time_check-=difference;
			difference/=2;
			going_down=1;
		}
	}
}
#endif

void choose_delay(void)
{
	UC done;

	slow_down=0;
	if(calc_speed()<100)
	{
		slow_down=0;
		return;
	}
	done=0;
	slow_down=1;
	while((slow_down<65535)&&(!done))
	{
		if(calc_speed()>100) slow_down++; else done=1;
	}
}

void choose_frame_skip(void)
{
	UC done;

	if(frame_skip>4) return;
	done=0;
	frame_skip=1;
	if(calc_speed()<100) frame_skip=2;
	while((frame_skip<5)&&(!done))
	{
		if(calc_speed()<100) frame_skip++; else done=1;
	}
}

#ifdef NO_ASM
void main_normal_loop(void)
{
	main_bit;
#ifdef BREAKPOINT
	if(pc.W==breakpoint) quit=QUIT_COMPLETELY;
#endif
	main_bit_2;
}
#else
void main_normal_loop(void)
{
	main_bit();
}
#endif

void main_8bit_loop(void)
{
	scr_driver=SMS_SD;
	main_normal_loop();
}

void main_8bit_loop_gg(void)
{
	scr_driver=GG_SD;
	main_normal_loop();
}

void main_mono_loop(void)
{
	scr_driver=MONO_SD;
	main_normal_loop();
}

void main(int argc, char *argv[])
{
  UC ULA_param=0;
  UC discard;

  error_str="No error.";

  strcpy(the_sna_path,argv[0]);
  strcpy(the_snap_path,argv[0]);
  strcpy(the_dump_path,argv[0]);
  strcpy(the_tap_path,argv[0]);
  strcpy(the_sav_path,argv[0]);
  strcpy(the_psg_path,argv[0]);
  strcpy(the_temp_file,"dump.tmp");

  grab_mem();

  _harderr(disk_err_handler);
  get_dos_drives();

  clean_regs();
  clear_ar_codes();

#ifdef OLD_NOISE
  adlib_present=InitAdlib();
#else
  init_DSP();
#endif
/*
  time_p=processor_speed();
*/
  time_d=delay_speed();

  bytes_pp=1;bitpix=8;mono_mode=1;Scr_Msb_First=0;
  parse_params(argc,argv);

  open_rom48();

  if(joy_present==255)
  {
	joy_present=0;
  }
  else
  {
	Joy_Detect();
  }
  if(joy_present) printf("Joysticks %d\n",joy_present);
  calibrate_joysticks();

  open_modem();
  if(!cart_in_mem) quit=QUIT_LOAD;

  x_scale=y_scale=1;
  init_table();
  make_table();
  open_z80table();

  init_screen();
  time_p=processor_speed(GG_SD,0,0);
  time_s_ggs=processor_speed(GG_SD,0,1)-time_p;
  time_s_ggb=processor_speed(GG_SD,1,1)-time_p;
  time_s_sms=processor_speed(SMS_SD,0,1)-time_p;
  pc.W=0;sp.W=0;
  if(!param_frame_skip)
  {
	choose_frame_skip();
  }
  choose_delay();

  init_keyboard();

  do
  {
	if(quit!=QUIT_NMI) screen_up=0;
#ifndef OLD_NOISE
	if(!ret_to_help) end_DSP();
#endif
	Sound_off();
	switch(quit)
	{
		case QUIT_HELP:
			help_scr();
			/* quit=DONT_QUIT; is now in help_scr() */
			break;
		case QUIT_SCR_DUMP:
			strcpy(the_path,the_dump_path);
			if(!(input_string(4,"Save Screen")))
			{
				if(save_screen())
				{
					strcpy(the_dump_path,the_path);
				}
			}
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_PAR:
			pro_action_replay();
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_JOY:
			joystick();
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_LOAD:
			global_index=sna_index;
			strcpy(the_path,the_sna_path);
			if(!(test_fsl(".sms",".gg","")))
			{
				old_machine_mode=gg_mode;
				if(different_extension(".gg",the_path))
				{
					gg_mode=0;
					if(!(open_sms()))
					{
						halt=0; /* Re-enable processor for new snap */
						clear_ar_codes();
						if(try_100)
						{
							scr_driver=SMS_SD;
							slow_down=0;
							choose_frame_skip();
							choose_delay();
						}
					}
					else
					{
						gg_mode=old_machine_mode;
					}
					make_line_table();
				}
				else
				{
					gg_mode=1;
					if(!(open_sms()))
					{
						halt=0;
						clear_ar_codes();
						if(try_100)
						{
							scr_driver=GG_SD;
							slow_down=0;
							choose_frame_skip();
							choose_delay();
						}
					}
					else
					{
						gg_mode=old_machine_mode;
					}
					make_line_table();
				}
			}
			strcpy(the_sna_path,the_path);
			sna_index=global_index;
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			if(!cart_in_mem) quit=QUIT_COMPLETELY;
			break;
		case QUIT_SAVE_SNAP:
			strcpy(the_path,the_snap_path);
			if(!(input_string(4,"Save Snap File")))
			{
				if(save_snap())
				{
					strcpy(the_snap_path,the_path);
				}
			}
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_LOAD_SNAP:
			global_index=snap_index;
			strcpy(the_path,the_snap_path);
			if(!(test_fsl(".msd",".ggd","")))
			{
				old_machine_mode=gg_mode;
				if(!(open_snap()))
				{
					halt=0; /* Re-enable processor for new snap */
					clear_ar_codes();
				}
				else
				{
					gg_mode=old_machine_mode;
				}
				make_line_table();
			}
			strcpy(the_snap_path,the_path);
			snap_index=global_index;
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_EMUL_OPTIONS:
			mess_up_options();
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_SOUND:
			strcpy(the_path,the_psg_path);
			sound_options();
			if(!all_sound_on)
			{
				Sound_off();
			}
			else
			{
				Sound_on();
			}
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_TALK:
			if(gg_connect)
			{
				request_talk_mode();
				if(quit==QUIT_TALK)
				{
					talk_mode();
				}
			}
			quit=DONT_QUIT;
			if(ret_to_help)
			{
				ret_to_help=0;
				quit=QUIT_HELP;
			}
			break;
		case QUIT_NMI:
			iff2=iff1;
			iff1=halt=0;
			INC_R_REG;
			push(pc.W);
			pc.W=102;
			t_state+=11;
			quit=DONT_QUIT;
			break;
		default:
			break;
	}
	if(quit==QUIT_HELP) continue;
	Sound_on();
#ifndef OLD_NOISE
	resume_DSP(); /* hopefully ret_to_help will prevent end_DSP */
#endif
	if(bitpix==1)
	{
		main_mono_loop();
	}
	else
	{
		if(gg_mode)
		{
			main_8bit_loop_gg();
		}
		else
		{
			main_8bit_loop();
		}
	}
  } while (quit!=QUIT_COMPLETELY);
  if(gg_connect) send_quit();

  if(cart_in_mem) release_cart_mem(no_of_16k_pages);
  if(PSG_open) fclose(p_handle);

  for(ptemp.W=0;ptemp.W<64;ptemp.W++)
  {
	dump_y[ptemp.W]=*(sprite_y+ptemp.W);
	dump_x[ptemp.W]=*(sprite_x+(ptemp.W<<1));
  }
  release_mem();

  release_keyboard();
  release_screen();
#ifdef OLD_NOISE
  TrashAdlib();
#else
  end_DSP();
#endif
  release_table();
  if(use_modem)
  {
	close_modem();
  }
  printf("%s\n",version_no);
  printf("%s\n",error_str);

  /*printf("AF=%u\n",af.W);
  printf("AF'=%u\n",af2.W);

  printf("HL=%u\n",hl.W);
  printf("DE=%u\n",de.W);
  printf("BC=%u\n",bc.W);

  printf("HL'=%u\n",hl2.W);
  printf("DE'=%u\n",de2.W);
  printf("BC'=%u\n",bc2.W);

  printf("IY=%u\n",iy.W);
  printf("IX=%u\n",ix.W);*/

  printf("vreg128 0x80=%3d vreg129 0x81=%3d\n",vreg128,vreg129);
  printf("vreg130 0x82=%3d vreg131 0x83=%3d\n",vreg130,vreg131);
  printf("vreg132 0x84=%3d vreg133 0x85=%3d\n",vreg132,vreg133);
  printf("vreg134 0x86=%3d vreg135 0x87=%3d\n",vreg134,vreg135);
  printf("vreg138 0x8A=%3d\n",vreg138);
  printf("SP=%u\n",sp.W);
  printf("PC=%u\n",pc.W);
  if(gg_mode)
  {
	printf("Game Gear mode\n");
  }
  else
  {
	printf("Master System mode\n");
  }
  printf("BRAM_page %d\n",BRAM_page);
  printf("ROM_4000 %d\n",ROM_4000);
  printf("ROM Page %d\n",ROM_pager);
  printf("TOP LINE %d\n",TOP_LINE);
  /*for(ptemp.W=0;ptemp.W<64;ptemp.W++)
  {
	printf(":%d,%d:",dump_x[ptemp.W],dump_y[ptemp.W]);
  }
  printf("\nsprite table address:%u\n",stored_sp_y);*/
}
