/******************************************/
/**                                      **/
/**          SMS_TAP Portable File       **/
/**                                      **/
/**          (C) James McKay 1996        **/
/**                                      **/
/**    This software may not be used     **/
/**    for commercial reasons, the code  **/
/**    may not be modified or reused     **/
/**    without permission.               **/
/**                                      **/
/******************************************/

void strip_file(char *stringy); /* In X128_FSL.C */

void open_z80table(void)
{
	word value, value2, index;
	UC buffer[512], tempc1, tempc2;
	char filename[MAXPATH];
	UC Lo, Pls, Mns, Res;

   strcpy(filename,"z80.tbl");
   printf("Filename:%s\n",filename);
   if (!(handle = fopen(filename,"rb")))
   {
      perror("Error:");
      printf("\nFile %s not present\n",filename);
      quit=QUIT_COMPLETELY;
   }
   fread(&buffer,1,24,handle); /* Skip TAP header */

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			rlca_f[value]=buffer[value*2];
			rlca_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			rrca_f[value]=buffer[value*2];
			rrca_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	for(value=0;value<256;value++)
	{
		if(!index)
		{
			rla_f0[value]=buffer[value*2];
			rla_a0[value]=buffer[(value*2)+1];
		}
		else
		{
			/*rla_f1[value]=buffer[value*2];*/
			rla_a1[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	for(value=0;value<256;value++)
	{
		if(!index)
		{
			rra_f0[value]=buffer[value*2];
			rra_a0[value]=buffer[(value*2)+1];
		}
		else
		{
			/*rra_f1[value]=buffer[value*2];*/
			rra_a1[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<8;index++)
   {
	fread(&buffer,1,512,handle);
	for(value=0;value<256;value++)
	{
		daa_f[index][value]=buffer[value*2];
		daa_a[index][value]=buffer[(value*2)+1];
	}
   }

   fread(&buffer,1,512,handle);

   for(value=0;value<256;value++)
   {
	inc_f[value]=buffer[value*2];
	/*inc_a[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);

   for(value=0;value<256;value++)
   {
	dec_f[value]=buffer[value*2];
	/*dec_a[value]=buffer[(value*2)+1];*/
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			rlcr_f[value]=buffer[value*2];
			rlcr_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			rrcr_f[value]=buffer[value*2];
			rrcr_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	for(value=0;value<256;value++)
	{
		if(!index)
		{
			rlr_f0[value]=buffer[value*2];
			rlr_a0[value]=buffer[(value*2)+1];
		}
		else
		{
			rlr_f1[value]=buffer[value*2];
			rlr_a1[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	for(value=0;value<256;value++)
	{
		if(!index)
		{
			rrr_f0[value]=buffer[value*2];
			rrr_a0[value]=buffer[(value*2)+1];
		}
		else
		{
			rrr_f1[value]=buffer[value*2];
			rrr_a1[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			sla_f[value]=buffer[value*2];
			sla_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			sra_f[value]=buffer[value*2];
			sra_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			sll_f[value]=buffer[value*2];
			sll_a[value]=buffer[(value*2)+1];
		}
	}
   }

   for(index=0;index<2;index++)
   {
	fread(&buffer,1,512,handle);
	if(!index)
	{
		for(value=0;value<256;value++)
		{
			srl_f[value]=buffer[value*2];
			srl_a[value]=buffer[(value*2)+1];
		}
	}
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f0[value]=buffer[value*2];
	/*bit_a0[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f1[value]=buffer[value*2];
	/*bit_a1[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f2[value]=buffer[value*2];
	/*bit_a2[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f3[value]=buffer[value*2];
	/*bit_a3[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f4[value]=buffer[value*2];
	/*bit_a4[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f5[value]=buffer[value*2];
	/*bit_a5[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f6[value]=buffer[value*2];
	/*bit_a6[value]=buffer[(value*2)+1];*/
   }

   fread(&buffer,1,512,handle);
   for(value=0;value<256;value++)
   {
	bit_f7[value]=buffer[value*2];
	/*bit_a7[value]=buffer[(value*2)+1];*/
   }

  fclose(handle);
  for(value=0;value<256;value++)
  {
	ora_table[value]=(value&168)|parity[value];
	ora_table[0]|=64;
	xora_table[value]=(value&168)|parity[value];
	xora_table[0]|=64;
	anda_table[value]=16|(value&168)|parity[value];
	anda_table[0]|=64;
	in_table[value]=(value&168)|(parity[value]);
	in_table[0]|=64; /* Don't forget to keep old C flag */
  }
  for(value=0;value<256;value++)
  {
	add8_table[value]=(value&168)|(value?0:64); /* Just HVC to do! */
	sub8_table[value]=(value&168)|(value?0:64)|2;
	cpsub8_table[value]=(value&128)|(value?0:64)|2; /* 5 bits left.. */
	add_HVC[value]=0;
	if(!(value&3)) /* 00 empty */
	{
		Lo=Pls=Res=0;
		if(value&4) Res=16;
		if(value&8) Pls=16;
		if(value&16) Lo=16;
		if(value&32) Res|=128;
		if(value&64) Pls|=128;
		if(value&128) Lo|=128;
		if((((Lo^Res)&(~Lo^Pls))>>7)) add_HVC[value]=4;
		if((Lo^Pls^Res)&16) add_HVC[value]|=16;
		if((~Lo&128)&(Pls&128)&(~Res&128)) add_HVC[value]|=1;
		if((Lo&128)&(~Pls&128)&(~Res&128)) add_HVC[value]|=1;
		if((Lo&128)&(Pls&128)&(~Res&128)) add_HVC[value]|=1;
		if((Lo&128)&(Pls&128)&(Res&128)) add_HVC[value]|=1;
	}
	add16_VNC[value]=add_HVC[value]&0xEF;
	sub_HVC[value]=0;
	if(!(value&3)) /* 00 empty */
	{
		Lo=Mns=Res=0;
		if(value&4) Res=16;
		if(value&8) Mns=16;
		if(value&16) Lo=16;
		if(value&32) Res|=128;
		if(value&64) Mns|=128;
		if(value&128) Lo|=128;
		if((((Lo^Res)&(~Mns^Res))>>7)) sub_HVC[value]=4;
		if((Lo^Mns^Res)&16) sub_HVC[value]|=16;
		if((~Lo&128)&(~Mns&128)&(Res&128)) sub_HVC[value]|=1;
		if((~Lo&128)&(Mns&128)&(~Res&128)) sub_HVC[value]|=1;
		if((~Lo&128)&(Mns&128)&(Res&128)) sub_HVC[value]|=1;
		if((Lo&128)&(Mns&128)&(Res&128)) sub_HVC[value]|=1;
	}
	sub16_VNC[value]=2|sub_HVC[value]&0xEF;
  }
}

void open_rom48(void)
{
	char filename[MAXPATH];
	word x;

   strcpy(filename,"char.set");
   printf("Filename:%s\n",filename);
   if (!(handle = fopen(filename,"rb")))
   {
      perror("Error:");
      printf("\nFile %s not present\n",filename);
      quit=QUIT_COMPLETELY;
      return;
   }
   fread(CSET,1,768,handle);
   fclose(handle);
   memset(VRAM,0,0x4000);
   for(x=0;x<768;x++)
   {
	*(VRAM+(x<<2))=*(CSET+x);
	*(VRAM+(x<<2)+3072)=*(CSET+x);
	*(VRAM+(x<<2)+3073)=255;
   }
   memcpy(CSET,VRAM,0x4000);
   memset(VRAM,0,0x4000);
}

void build_SAV_path(void)
{
	char extension[5];
	int pos;

	strcpy(the_sav_path,the_path);
	strcpy(extension,".sav");
	pos=strlen(the_sav_path);
	pos--;
	while((the_sav_path[pos]!='.')&&(pos)&&
	(the_sav_path[pos]!='\\')&&(the_sav_path[pos]!='/')) pos--;

	if(the_sav_path[pos]=='.') the_sav_path[pos]='\0'; /* If ext, then cut */
	if((strlen(the_sav_path)-MAXPATH)>3)
	{
		strcat(the_sav_path,(char *)extension);
	}
}

UC open_sms(void)
{
	char filename[MAXPATH];
	long temp_long;

/*#ifdef NON_WINDOWS
	release_screen();
#endif
	release_keyboard();
	printf("Enter SNA to load : ");
	scanf("%s",filename);
	if (!(handle = fopen(the_path,"rb")))
	{
		perror("Error:");
		printf("File %s not present\n",filename);
#ifdef NON_WINDOWS
		init_screen();
#endif
		init_keyboard();
		return 1;
	   }*/
   if(!(handle = fopen(the_path,"rb")))
   {
	perror("Error:");
	printf("File %s not present\n",filename);
	if(!cart_in_mem) no_of_16k_pages=0;
	return 1;
   }
   if(cart_in_mem) release_cart_mem(no_of_16k_pages);
   clean_regs();
   fseek(handle,0,SEEK_END);
   temp_long=ftell(handle);
   fseek(handle,0,SEEK_SET);
   no_of_16k_pages=temp_long/16384;
   rom_limit=no_of_16k_pages-1;
   if(rom_limit==23) rom_limit=31; /* Battleships */
   if((temp_long-(no_of_16k_pages*16384))==512)
   {
	   /*printf("Skipping 512 byte header\n");*/
	   fseek(handle,512,SEEK_SET);
   }
   build_SAV_path();
   grab_cart_mem(no_of_16k_pages);

   fclose(handle);
/*#ifdef NON_WINDOWS
	init_screen();
	init_keyboard();
#endif*/
   return 0; /* Success */
}

/* Just in case I write the sound to a file */
void save_PSG(void)
{
	UC resolved;
	char extension[5];
	int pos;

#ifdef ACTUALLY_WANT_PSG
	strcpy(extension,".psg");
	pos=strlen(the_path);
	pos--;
	while((the_path[pos]!='.')&&(pos)&&
	(the_path[pos]!='\\')&&(the_path[pos]!='/')) pos--;

	if(the_path[pos]=='.') the_path[pos]='\0'; /* If ext, then cut */
	if((strlen(the_path)-MAXPATH)>3)
	{
		strcat(the_path,(char *)extension);
	}

	if((handle = fopen(the_path,"rb"))!=NULL)
	{
		fclose(handle);
		release_keyboard();
		scr_copy();
		make_box(0,3,32,19,79);
		scr_write_string(8,4,79,"CREATE PSG FILE");
		scr_write_string(0,6,79,the_path);
		scr_write_string(8,17,79,"Overwrite (Y/N)?");
		RePaintScreen();
		resolved=0;
		while(!resolved)
		{
			switch(fsl_asciiext_key())
			{
				case X128_ESCAPE:
				case 'n':
				case 'N':
					scr_restore();
					init_keyboard();
					return;
				case 'y':
				case 'Y':
					resolved=1;
					break;
				default:
					break;
			}
		}
		scr_restore();
		init_keyboard();
	}
	if(!(p_handle = fopen(the_path,"wb")))
	{
		release_keyboard();
		scr_copy();
		make_box(2,3,29,19,79);
		scr_write_string(8,4,79,"CREATE PSG FILE");
		scr_write_string(5,10,79,"Could not create file!");
		scr_write_string(5,17,79,"PRESS ESCAPE TO RETURN.");
		RePaintScreen();
		while(fsl_extend_key()!=X128_ESCAPE);
		scr_restore();
		init_keyboard();
		return;
	}
	else
	{
		fwrite("PSG\032\0\0\0\0\0\0\0\0\0\0\0\0",1,16,p_handle);
	}
#else
	if(!(p_handle = fopen("log.log","wb")))
	{
		printf("Nasty error with PSG\n");
		return;
	}
#endif
}

void open_DAT(void)
{
	return;
}

UC TAP_load(UC id_a, word start_ix, word length_de)
{
	return 0;
}

/* Just in case I do 'snaps' of ram */
UC open_snap(void)
{
	char filename[MAXPATH];
	long temp_long;
	char ID_STR[10];
	pair ptemp;
	UC x, zero, ver_num, btemp;

   if(!(handle = fopen(the_path,"rb")))
   {
	perror("Error:");
	printf("File %s not present\n",filename);
	return 1;
   }

	fread(ID_STR,1,9,handle);
	if((strncmp("S8B SNAP",ID_STR,8))) {fclose(handle);return 1;}

	fread(&ver_num,1,1,handle);
	if(ver_num)
	{
		printf("Warning!  Version number higher than 0!\n");
	}
	fread(&gg_mode,1,1,handle);
	fread(&japan,1,1,handle);
	fread(&fm_present,1,1,handle);

	fread(&port0,1,1,handle);
	fread(&port1,1,1,handle);
	fread(&port2,1,1,handle);
	fread(&port3,1,1,handle);
	fread(&port4,1,1,handle);
	fread(&port5,1,1,handle);
	fread(&zero/*port6*/,1,1,handle);

	fread(&zero/*port62*/,1,1,handle);
	fread(&port63,1,1,handle);

	for(x=0;x<8;x++)
	{
		fread(&ptemp.B.l,1,1,handle);
		fread(&ptemp.B.h,1,1,handle);
		PSG[x]=ptemp.W;
	}
	Set_Tone(0);
	Set_Tone(1);
	Set_Tone(2);
	Set_Tone(3);

	fread(&waiting_127,1,1,handle);
	fread(&first_127,1,1,handle);

	fread(&vreg128,1,1,handle);
	out(0,191,vreg128);
	out(0,191,128);
	fread(&vreg129,1,1,handle);
	out(0,191,vreg129);
	out(0,191,129);
	fread(&vreg130,1,1,handle);
	out(0,191,vreg130);
	out(0,191,130);
	fread(&vreg131,1,1,handle);
	out(0,191,vreg131);
	out(0,191,131);
	fread(&vreg132,1,1,handle);
	out(0,191,vreg132);
	out(0,191,132);
	fread(&vreg133,1,1,handle);
	out(0,191,vreg133);
	out(0,191,133);
	fread(&vreg134,1,1,handle);
	out(0,191,vreg134);
	out(0,191,134);
	fread(&vreg135,1,1,handle);
	out(0,191,vreg135);
	out(0,191,135);
	fread(&x_scroll,1,1,handle);
	out(0,191,x_scroll);
	out(0,191,136);
	fread(&y_scroll,1,1,handle);
	out(0,191,x_scroll);
	out(0,191,137);
	fread(&vreg138,1,1,handle);
	out(0,191,vreg138);
	out(0,191,138);

	fread(&ptemp.B.l,1,1,handle); /* vdp_addr */
	fread(&ptemp.B.h,1,1,handle);
	out(0,191,ptemp.B.l);
	out(0,191,ptemp.B.h);

	fread(&waiting_191,1,1,handle);
	fread(&first_191,1,1,handle);

	fread(&ptemp.B.l,1,1,handle);
	fread(&ptemp.B.h,1,1,handle);
	vline=ptemp.W;
	fread(&background_counter,1,1,handle);

	fread(&port222,1,1,handle);

	fread(&btemp,1,1,handle);
	out(0,240,btemp); /* fm_reg, port240 */
	fread(&port242,1,1,handle);
	fread(&fm_chip,1,64,handle);

	fread(&BRAM_page,1,1,handle);
	spokeb(65532,BRAM_page);
	fread(&zero,1,1,handle); /* 65533 */
	fread(&ROM_4000,1,1,handle);
	spokeb(65534,ROM_4000);
	fread(&ROM_pager,1,1,handle);
	spokeb(65535,ROM_pager);

	fread(RAM_C000,1,8192,handle);
	fread(VRAM,1,16384,handle);
	if(gg_mode)
	{
		fread(VPAL,1,64,handle);
		for(x=0;x<32;x++)
		{
			calc_gg_pal(x<<1);
		}
	}
	else
	{
		fread(VPAL,1,32,handle);
	}
	fread(BRAM[0],1,16384,handle);
	fread(BRAM[1],1,16384,handle);

	fread(&af.B.l,1,1,handle);
	fread(&af.B.h,1,1,handle);
	fread(&bc.B.l,1,1,handle);
	fread(&bc.B.h,1,1,handle);
	fread(&hl.B.l,1,1,handle);
	fread(&hl.B.h,1,1,handle);
	fread(&pc.B.l,1,1,handle);
	fread(&pc.B.h,1,1,handle);
	fread(&sp.B.l,1,1,handle);
	fread(&sp.B.h,1,1,handle);
	fread(&ir.B.h,1,1,handle);
	fread(&btemp,1,1,handle);
	ir.B.l=btemp&127;
	bit7_r=btemp&128;

	fread(&de.B.l,1,1,handle);
	fread(&de.B.h,1,1,handle);
	fread(&bc2.B.l,1,1,handle);
	fread(&bc2.B.h,1,1,handle);
	fread(&de2.B.l,1,1,handle);
	fread(&de2.B.h,1,1,handle);
	fread(&hl2.B.l,1,1,handle);
	fread(&hl2.B.h,1,1,handle);
	fread(&af2.B.l,1,1,handle);
	fread(&af2.B.h,1,1,handle);
	fread(&iy.B.l,1,1,handle);
	fread(&iy.B.h,1,1,handle);
	fread(&ix.B.l,1,1,handle);
	fread(&ix.B.h,1,1,handle);
	fread(&iff1,1,1,handle); /* 1=ei */
	fread(&iff2,1,1,handle);
	fread(&im,1,1,handle); /* 0,1,2 */

   fclose(handle);
   return 0; /* Success */
}

UC save_snap(void)
{
	UC zero, btemp, x, ver_num, resolved;
	char extension[5];
	pair ptemp;
	int pos;

	if(gg_mode) /* Hopefully this is right! */
	{
		strcpy(extension,".ggd");
	}
	else
	{
		strcpy(extension,".msd");
	}
	pos=strlen(the_path);
	pos--;
	while((the_path[pos]!='.')&&(pos)&&
	(the_path[pos]!='\\')&&(the_path[pos]!='/')) pos--;

	if(the_path[pos]=='.') the_path[pos]='\0'; /* If ext, then cut */
	if((strlen(the_path)-MAXPATH)>3)
	{
		strcat(the_path,(char *)extension);
	}

	zero=0;
	if((handle = fopen(the_path,"rb"))!=NULL)
	{
		fclose(handle);
		release_keyboard();
		scr_copy();
		make_box(0,3,32,19,79);
		scr_write_string(9,4,79,"SAVE SNAP FILE");
		scr_write_string(0,6,79,the_path);
		scr_write_string(8,17,79,"Overwrite (Y/N)?");
		RePaintScreen();
		resolved=0;
		while(!resolved)
		{
			switch(fsl_asciiext_key())
			{
				case X128_ESCAPE:
				case 'n':
				case 'N':
					scr_restore();
					init_keyboard();
					return 0;
				case 'y':
				case 'Y':
					resolved=1;
					break;
				default:
					break;
			}
		}
		scr_restore();
		init_keyboard();
	}
	if(!(handle = fopen(the_path,"wb")))
	{
		release_keyboard();
		scr_copy();
		make_box(2,3,29,19,79);
		scr_write_string(9,4,79,"SAVE SNAP FILE");
		scr_write_string(5,10,79,"Could not create file!");
		scr_write_string(5,17,79,"PRESS ESCAPE TO RETURN.");
		RePaintScreen();
		while(fsl_extend_key()!=X128_ESCAPE);
		scr_restore();
		init_keyboard();
		return 0;
	}
	else
	{
		fwrite("S8B SNAP\0",1,9,handle);
		ver_num=0;
		fwrite(&ver_num,1,1,handle);
		fwrite(&gg_mode,1,1,handle);
		fwrite(&japan,1,1,handle);
		fwrite(&fm_present,1,1,handle);

		fwrite(&port0,1,1,handle);
		fwrite(&port1,1,1,handle);
		fwrite(&port2,1,1,handle);
		fwrite(&port3,1,1,handle);
		fwrite(&port4,1,1,handle);
		fwrite(&port5,1,1,handle);
		fwrite(&zero/*port6*/,1,1,handle);

		fwrite(&zero/*port62*/,1,1,handle);
		fwrite(&port63,1,1,handle);

		for(x=0;x<8;x++)
		{
			ptemp.W=PSG[x];
			fwrite(&ptemp.B.l,1,1,handle);
			fwrite(&ptemp.B.h,1,1,handle);
		}
		fwrite(&waiting_127,1,1,handle);
		fwrite(&first_127,1,1,handle);

		fwrite(&vreg128,1,1,handle);
		fwrite(&vreg129,1,1,handle);
		fwrite(&vreg130,1,1,handle);
		fwrite(&vreg131,1,1,handle);
		fwrite(&vreg132,1,1,handle);
		fwrite(&vreg133,1,1,handle);
		fwrite(&vreg134,1,1,handle);
		fwrite(&vreg135,1,1,handle);
		fwrite(&x_scroll,1,1,handle);
		fwrite(&y_scroll,1,1,handle);
		fwrite(&vreg138,1,1,handle);

		if(vdp_pal)
		{
			ptemp.W=vdp_addr+0xC000;
		}
		else
		{
			ptemp.W=vdp_addr+0x4000;
		}
		fwrite(&ptemp.B.l,1,1,handle);
		fwrite(&ptemp.B.h,1,1,handle);

		fwrite(&waiting_191,1,1,handle);
		fwrite(&first_191,1,1,handle);

		ptemp.W=vline;
		fwrite(&ptemp.B.l,1,1,handle);
		fwrite(&ptemp.B.h,1,1,handle);
		fwrite(&background_counter,1,1,handle);

		fwrite(&port222,1,1,handle);

		fwrite(&fm_reg/*port240*/,1,1,handle);
		fwrite(&port242,1,1,handle);
		fwrite(&fm_chip,1,64,handle);

		fwrite(&BRAM_page,1,1,handle);
		fwrite(&zero,1,1,handle); /* 65533 */
		fwrite(&ROM_4000,1,1,handle);
		fwrite(&ROM_pager,1,1,handle);

		fwrite(RAM_C000,1,8192,handle);
		fwrite(VRAM,1,16384,handle);
		if(gg_mode)
		{
			fwrite(VPAL,1,64,handle);
		}
		else
		{
			fwrite(VPAL,1,32,handle);
		}
		fwrite(BRAM[0],1,16384,handle);
		fwrite(BRAM[1],1,16384,handle);

		fwrite(&af.B.l,1,1,handle);
		fwrite(&af.B.h,1,1,handle);
		fwrite(&bc.B.l,1,1,handle);
		fwrite(&bc.B.h,1,1,handle);
		fwrite(&hl.B.l,1,1,handle);
		fwrite(&hl.B.h,1,1,handle);
		fwrite(&pc.B.l,1,1,handle);
		fwrite(&pc.B.h,1,1,handle);
		fwrite(&sp.B.l,1,1,handle);
		fwrite(&sp.B.h,1,1,handle);
		fwrite(&ir.B.h,1,1,handle);
		btemp=ir.B.l|bit7_r;
		fwrite(&btemp,1,1,handle);

		fwrite(&de.B.l,1,1,handle);
		fwrite(&de.B.h,1,1,handle);
		fwrite(&bc2.B.l,1,1,handle);
		fwrite(&bc2.B.h,1,1,handle);
		fwrite(&de2.B.l,1,1,handle);
		fwrite(&de2.B.h,1,1,handle);
		fwrite(&hl2.B.l,1,1,handle);
		fwrite(&hl2.B.h,1,1,handle);
		fwrite(&af2.B.l,1,1,handle);
		fwrite(&af2.B.h,1,1,handle);
		fwrite(&iy.B.l,1,1,handle);
		fwrite(&iy.B.h,1,1,handle);
		fwrite(&ix.B.l,1,1,handle);
		fwrite(&ix.B.h,1,1,handle);
		fwrite(&iff1,1,1,handle); /* 1=ei */
		fwrite(&iff2,1,1,handle);
		fwrite(&im,1,1,handle); /* 0,1,2 */

		fclose(handle);
	}
	return 1;
}

/* subroutine for writing an encoded byte pair
(or single byte  if it doesn't encode) to a file */
UC encput(UC byt, UC cnt, FILE *fid) /* returns count of bytes written, 0 if err */
{
	UC btemp;

	if(cnt)
	{
		if( (cnt==1) && (0xc0 != (0xc0&byt)) )
		{
			fwrite(&byt,1,1,fid);
			return(1);
		}
		else
		{
			btemp=0xC0|cnt;
			fwrite(&btemp,1,1,fid);
			fwrite(&byt,1,1,fid);
			return(2);
		}
	}
	return(0);
}

word encLine(UC *inBuff, word inLen, FILE *fp)
{  /* returns number of bytes written into outBuff, 0 if failed */
	UC this_one, last;
	int srcIndex, i;
	register int total;
	register UC runCount; /* max single runlength is 63 */

	total = 0;
	last = *(inBuff);
	runCount = 1;

	for (srcIndex = 1; srcIndex<inLen; srcIndex++)
	{
		this_one = *(++inBuff);
		if (this_one == last)
		{
			runCount++;	/* it encodes */
			if(runCount == 63)
			{
				if (!(i=encput(last, runCount, fp)))
					return(0);
				total += i;
				runCount = 0;
			}
		}
		else
		{   /* this_one != last */
			if (runCount)
			{
				if (!(i=encput(last, runCount, fp)))
					return(0);
				total += i;
			}
			last = this_one;
			runCount = 1;
		}
	}	/* endloop */
	if (runCount)
	{	/* finish up */
		if (!(i=encput(last, runCount, fp)))
			return(0);
		return(total + i);
	}
	return(total);
}

void dump_pcx(FILE *pcx_handle)
{
	UC btemp, R, G, B;
	word y;
	static char PCX_header[128]=
	{
		10, /* ID */
		5,  /* V3.0 (has 256 colour palette */
		1,  /* Is compressed */
		8,  /* 8 bits per pixel */

		0,0,   /* Xmin */
		0,0,   /* Ymin */
		63,1,  /* Xmax */
		199,0, /* Ymax (0,0)-(319,199) */

		64,1,  /* Creating device is 320 pixels wide */
		200,0, /* Creating device is 200 pixels deep 320x200 */

		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* Colourmap */
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* Old Style */
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

		0, /* Reserved */
		1, /* Number of colour planes */
		64,1, /* 320 bytes per line */
		1,0, /* Palette is colour/BW */

		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 58 byte filler */
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0
	};

	/* Write header */
	fwrite(&PCX_header,1,128,pcx_handle);
	/* Write Data */
	for(y=0;y<200;y++)
	{
		if(!(encLine((SCREEN+(320*y)),320,pcx_handle)))
		{
			printf("Nasty %d\n",y);
		}
	}
	/* Write Palette */
	btemp=12;
	fwrite(&btemp,1,1,pcx_handle);
	for(y=0;y<256;y++)
	{
		read_24_bit_pal(y,&R,&G,&B);
		fwrite(&R,1,1,pcx_handle);
		fwrite(&G,1,1,pcx_handle);
		fwrite(&B,1,1,pcx_handle);
	}
}

UC save_screen(void)
{
	UC btemp, resolved;
	char extension[5];
	pair ptemp;
	int pos;

	strcpy(extension,".pcx");
	pos=strlen(the_path);
	pos--;
	while((the_path[pos]!='.')&&(pos)&&
	(the_path[pos]!='\\')&&(the_path[pos]!='/')) pos--;

	if(the_path[pos]=='.') the_path[pos]='\0'; /* If ext, then cut */
	if((strlen(the_path)-MAXPATH)>3)
	{
		strcat(the_path,(char *)extension);
	}

	if((handle = fopen(the_path,"rb"))!=NULL)
	{
		fclose(handle);
		release_keyboard();
		scr_copy();
		make_box(0,3,32,19,79);
		scr_write_string(10,4,79,"SAVE SCREEN");
		scr_write_string(0,6,79,the_path);
		scr_write_string(8,17,79,"Overwrite (Y/N)?");
		RePaintScreen();
		resolved=0;
		while(!resolved)
		{
			switch(fsl_asciiext_key())
			{
				case X128_ESCAPE:
				case 'n':
				case 'N':
					scr_restore();
					init_keyboard();
					return 0;
				case 'y':
				case 'Y':
					resolved=1;
					break;
				default:
					break;
			}
		}
		scr_restore();
		init_keyboard();
	}
	if(!(handle = fopen(the_path,"wb")))
	{
		release_keyboard();
		scr_copy();
		make_box(2,3,29,19,79);
		scr_write_string(10,4,79,"SAVE SCREEN");
		scr_write_string(5,10,79,"Could not create file!");
		scr_write_string(5,17,79,"PRESS ESCAPE TO RETURN.");
		RePaintScreen();
		while(fsl_extend_key()!=X128_ESCAPE);
		scr_restore();
		init_keyboard();
		return 0;
	}
	else
	{
		if(scr_driver==GG_SD)
		{
			RePaintScreenGG();
		}
		else
		{
			RePaintScreen();
		}
		dump_pcx(handle);
	}
	fclose(handle);
	return 1;
}

int get_length_of_pre(char *stringy)
{
/* Assumes that extension has already been stripped and that there is no
 / or \ at the end of this string */
	int pos, pre_len;

	pos=strlen(stringy);
	pos--;
	pre_len=0;
	while((stringy[pos]!='/')&&(stringy[pos]!='\\')&&(pos>=0))
	{
		pre_len++;
		pos--;
	}
	return pre_len;
}

void wtoa_temp(char *stringy, word x)
{
	char *original_point;
	word temp;

	original_point=stringy;
	temp=0;
	while(x>=10000)
	{
		x-=10000;
		temp++;
	}
	*stringy++=temp+'0';
	temp=0;
	while(x>=1000)
	{
		x-=1000;
		temp++;
	}
	*stringy++=temp+'0';
	temp=0;
	while(x>=100)
	{
		x-=100;
		temp++;
	}
	*stringy++=temp+'0';
	temp=0;
	while(x>=10)
	{
		x-=10;
		temp++;
	}
	*stringy++=temp+'0';
	*stringy++=x+'0';
	*stringy='\0';
	stringy=original_point;
}

void itoa_temp(char *stringy, UC x)
{
	char *original_point;
	UC temp;

	original_point=stringy;
	temp=0;
	if(x>=100)
	{
		temp=0;
		while(x>=100)
		{
			x-=100;
			temp++;
		}
		*stringy++=temp+'0';
	}
	if(x>=10)
	{
		temp=0;
		while(x>=10)
		{
			x-=10;
			temp++;
		}
		*stringy++=temp+'0';
	}
	else
	{
		if(temp) /* 100's but not 10's */
		{
			*stringy++='0';
		}
	}
	*stringy++=x+'0';
	*stringy='\0';
	stringy=original_point;
}
