/* (c) James McKay : sms_tbl.c */

UC *scr_x_y(UC attr, UC data, UC offset)
{
	return (scr_table+(attr*width_of_table_line)+
		(width_of_nib*data)+offset);
}

void flip_mono(void)
{
	unsigned long x;
	UC *scr, *bor;

	if(bitpix==1)
	{
		scr=scr_table;
		bor=border_table;
		for(x=0;x<64*width_of_table_line;x++)
		{
			*scr++^=255;
		}
		for(x=0;x<width_of_half_border*8;x++)
		{
			*bor++^=255;
		}
	}
}

void mono_table_entry(UC attr, UC data)
{
	UC scr_val, ink, paper, bit_p;
	word byte_offset, bit_offset, x, y;
	pair temp;

	temp.W=0;
	ink=attr&7;
	paper=(attr&56)>>3;
	scr_val=0;
	temp.B.h=data;
	for(bit_p=0;bit_p<8;bit_p++)
	{
		temp.W>>=1;
		if((temp.B.l&128)==128)
		{
			if(paper>3) /* White back */
			{
				if(ink!=paper)
				{
					if(Scr_Msb_First)
					{
						scr_val|=ormask[bit_p];
					}
					else
					{
						scr_val|=ormask[7-bit_p];
					}
				}
			}
			else
			{
				if(ink==paper)
				{
					if(Scr_Msb_First)
					{
						scr_val|=ormask[bit_p];
					}
					else
					{
						scr_val|=ormask[7-bit_p];
					}
				}
			}
		}
		else
		{
			if(paper<4) /* Black back */
			{
				if(Scr_Msb_First)
				{
					scr_val|=ormask[bit_p];
				}
				else
				{
					scr_val|=ormask[7-bit_p];
				}
			}
		}
	}
	/* Ok, we have a byte, now scale it up */
	temp.W=scr_val;
	byte_offset=0;bit_offset=7;
	memset(scr_x_y(attr,data,0),0,width_of_nib);
	for(x=0;x<8;x++)
	{
		temp.W<<=1;
		for(y=0;y<x_scale;y++)
		{
			if(temp.B.h&1) *scr_x_y(attr,data,byte_offset)|=ormask[bit_offset];
			if(!bit_offset--)
			{
				bit_offset=7;
				byte_offset++;
			}
		}
	}
}

void table_entry(UC attr, UC data, UC and_er, UC pos)
{
	word temp_lo, temp_hi;
	unsigned long write_val;
	UC z0, z1, z2, z3, x, max, temp_0, temp_1, temp_2, temp_3;
	static UC error_done=0;

#ifdef NON_WINDOWS
	if(data&and_er)
	{
		write_val=fore_attrib[attr];
	}
	else
	{
		write_val=back_attrib[attr];
	}
#else
	if(data&and_er)
	{
		write_val=XPal[fore_attrib[attr]];
	}
	else
	{
		write_val=XPal[back_attrib[attr]];
	}
#endif
	temp_lo=write_val&0xFFFF;
	temp_0=temp_lo&0xFF;
	temp_1=(temp_lo&0xFF00)>>8;
	temp_hi=(write_val&0xFFFF0000)>>16;
	temp_2=temp_hi&0xFF;
	temp_3=(temp_hi&0xFF00)>>8;
	pos*=bytes_pp*x_scale;
	max=bytes_pp-1;
	if(Scr_Msb_First)
	{
		z0=max+pos;z1=max-1+pos;z2=max-2+pos;z3=pos;
	}
	else
	{
		z0=pos;z1=1+pos;z2=2+pos;z3=3+pos;
	}
	x=x_scale;
	while(x--)
	{
		switch(bytes_pp)
		{
			case 1:
				memcpy(scr_x_y(attr,data,z0),&temp_0,1);
				break;
			case 2:
				memcpy(scr_x_y(attr,data,z1),&temp_1,1);
				memcpy(scr_x_y(attr,data,z0),&temp_0,1);
				break;
			case 3: 
				memcpy(scr_x_y(attr,data,z2),&temp_2,1);        
				memcpy(scr_x_y(attr,data,z1),&temp_1,1);
				memcpy(scr_x_y(attr,data,z0),&temp_0,1);
				break;
			case 4:
				memcpy(scr_x_y(attr,data,z3),&temp_3,1);
				memcpy(scr_x_y(attr,data,z2),&temp_2,1);
				memcpy(scr_x_y(attr,data,z1),&temp_1,1);
				memcpy(scr_x_y(attr,data,z0),&temp_0,1);
				break;
			default:
				if(error_done) break;
				error_done=1;
				printf("Nasty error with bytes_pp!\n");
				quit=QUIT_COMPLETELY;
				return;
		}
		z0+=bytes_pp;z1+=bytes_pp;z2+=bytes_pp;z3+=bytes_pp;
	}
	memcpy(scr_x_y(128|reverse_attr[attr],data,0),
			scr_x_y(attr,data,0),width_of_nib);
}

void init_table(void)
{
	word attr;

	if(bitpix<8)
	{
		attr=64;
		bytes_pp=0;
		byte_width_of_scr=width_of_scr/8;
		width_of_nib=x_scale;
		width_of_table_line=256*width_of_nib;
		width_of_half_border=4*x_scale;
	}
	else
	{
		attr=256;
		bytes_pp=bitpix>>3;
		byte_width_of_scr=width_of_scr*bytes_pp;
		width_of_nib=bytes_pp*x_scale*4;
		width_of_table_line=16*width_of_nib;
		width_of_half_border=32*x_scale*bytes_pp;
	}
	if(!(scr_table=(UC *)malloc(sizeof(UC)*attr*width_of_table_line)))
	{
		printf("Can't allocate scr_table\n");
		quit=QUIT_COMPLETELY;
	}
	if(!(border_table=(UC *)malloc(sizeof(UC)*8*width_of_half_border)))
	{
		printf("Can't allocate border_table\n");
		quit=QUIT_COMPLETELY;
	}
}

void release_table(void)
{
	free(scr_table);
	free(border_table);
}

void make_line_table(void)
{
	int x,y;

	if(big_gg)
	{
		if(gg_mode)
		{
			x=0;
			for(y=0;y<144;y++)
			{
				vga_x_y[y+24]=((x+10)*320);
				x++;
				if(!(y&3)) x++;
#ifdef NON_WINDOWS
				vga_x_y[y+24]+=32;
#endif
			}
		}
		else
		{
			for (y=0;y<192;y++)
			{
				vga_x_y[y]=((y+4)*320);
#ifdef NON_WINDOWS
				vga_x_y[y]+=32;
#endif
			}
		}
	}
	else
	{
		for (y=0;y<192;y++)
		{
			vga_x_y[y]=((y+4)*320);
#ifdef NON_WINDOWS
			vga_x_y[y]+=32;
#endif
		}
	}
}

void make_table(void)
{
	int v,x,y,z;
	pair temp;
	quadruple qtemp;

	make_line_table();
	for(x=0;x<256;x++)
	{
		msb_bspread3[x]=0;
		msb_bspread2[x]=0;
		msb_bspread1[x]=0;
		msb_bspread0[x]=0;
		if(x&16)
		{
			msb_bspread3[x]|=0x08000000;
			msb_bspread2[x]|=0x04000000;
			msb_bspread1[x]|=0x02000000;
			msb_bspread0[x]|=0x01000000;
		}
		if(x&32)
		{
			msb_bspread3[x]|=0x00080000;
			msb_bspread2[x]|=0x00040000;
			msb_bspread1[x]|=0x00020000;
			msb_bspread0[x]|=0x00010000;
		}
		if(x&64)
		{
			msb_bspread3[x]|=0x00000800;
			msb_bspread2[x]|=0x00000400;
			msb_bspread1[x]|=0x00000200;
			msb_bspread0[x]|=0x00000100;
		}
		if(x&128)
		{
			msb_bspread3[x]|=0x00000008;
			msb_bspread2[x]|=0x00000004;
			msb_bspread1[x]|=0x00000002;
			msb_bspread0[x]|=0x00000001;
		}
		lsb_bspread3[x]=0;
		lsb_bspread2[x]=0;
		lsb_bspread1[x]=0;
		lsb_bspread0[x]=0;
		if(x&1)
		{
			lsb_bspread3[x]|=0x08000000;
			lsb_bspread2[x]|=0x04000000;
			lsb_bspread1[x]|=0x02000000;
			lsb_bspread0[x]|=0x01000000;
		}
		if(x&2)
		{
			lsb_bspread3[x]|=0x00080000;
			lsb_bspread2[x]|=0x00040000;
			lsb_bspread1[x]|=0x00020000;
			lsb_bspread0[x]|=0x00010000;
		}
		if(x&4)
		{
			lsb_bspread3[x]|=0x00000800;
			lsb_bspread2[x]|=0x00000400;
			lsb_bspread1[x]|=0x00000200;
			lsb_bspread0[x]|=0x00000100;
		}
		if(x&8)
		{
			lsb_bspread3[x]|=0x00000008;
			lsb_bspread2[x]|=0x00000004;
			lsb_bspread1[x]|=0x00000002;
			lsb_bspread0[x]|=0x00000001;
		}

	}
	if(quit==QUIT_COMPLETELY) return;
	if(bytes_pp)
	{
		for (y=0;y<128;y++)
		{
			for (x=0;x<16;x++)
			{
				memset(scr_x_y(y,x,0),0,width_of_nib);
				table_entry(y,x,8,0);
				table_entry(y,x,4,1);
				table_entry(y,x,2,2);
				table_entry(y,x,1,3);
			}
		}
		for (y=0;y<8;y++)
		{
			for(x=0;x<32;x++)
			{
				memcpy(border_table+(x*bytes_pp*x_scale)+
					(width_of_half_border*y),
					scr_x_y(y<<3,0,0),bytes_pp*x_scale);
			}
		}
	}
	else
	{
		for(y=0;y<64;y++)
		{
			for(x=0;x<256;x++)
			{
				memset(scr_x_y(y,x,0),0,width_of_nib);
				mono_table_entry(y,x);
			}
		}
		for (y=0;y<8;y++)
		{
			for(x=0;x<4;x++)
			{
				memcpy(border_table+(x*x_scale)+
					(width_of_half_border*y),
					scr_x_y(y<<3,0,0),x_scale);
			}
		}
		if(mono_mode==1) flip_mono();
	}
	for (x=0;x<256;x++)
	{
		calc_parity(x);
		parity[x]=(af.B.l&4);
	}
	for (x=0;x<8;x++)
	{
		SKey[x]=255;
	}
}

void lower_it(char *stringy)
{
	int pos, x;

	pos=strlen(stringy);
	for(x=0;x<pos;x++)
	{
		stringy[x]=tolower(stringy[x]);
	}
}

void parse_params(int argc, char *param[])
{
	char temp_str[MAXPATH];
	int arg_num;
	UC file_valid, x;

	if(quit==QUIT_COMPLETELY) return; /* Rom missing */
	arg_num=1;
	file_valid=0;
	while(arg_num<argc)
	{
		if((param[arg_num][0]=='-')||(param[arg_num][0]=='/'))
		{
			strcpy(temp_str,(char *)param[arg_num]+1);
			lower_it((char *)temp_str);
			if(!(strcmp(temp_str,"?")))
			{
				printf("%s\n",version_no);
				printf("\nOptions:\n");
				printf("/?     - This help.\n");
				printf("/quiet - Sound is off.\n");
				printf("/li <number> - Select Line Int");
				printf(" Method (0-2)\n");
				printf("/delay <number> - Set delay level");
				printf(" (0-65535)\n");
				printf("/frame <number> - Set frame skip");
				printf(" (0-255)\n");
				printf("/fm  - Japanese FM chip\n");
				printf("/jap - Japanese Mark 3\n");
				printf("/nojoy - No Joystick Detection\n");
				printf("/ggpad - Use Gravis Gamepad (or");
				printf(" equivalent 4 button pad)\n");
				printf("/p2joy - Lets you play 2 player SMS games");
				printf(" if you have only 1 joystick\n");
				printf("/bswap - Swaps button 1 & 2 on PC Joystick\n");
				printf("/ggbig - Use larger GG screen\n");
				printf("\n/baud <num> - Baud rate, up to 115200\n");
				printf("/com  <1-4> - COM number of port\n");
				printf("If using non standard COM port:\n");
				printf("	/port <hex> - Port base address\n");
				printf("	/irq  <num> - Port IRQ number\n");

				printf("\n/dial <phone number with no spaces>\n");
				printf("/receive - Auto answer mode (modem)\n");
				printf("/nullt - null modem cable transmit\n");
				printf("/nullr - null modem cable receive\n");
#ifndef NON_WINDOWS
				printf("/noshm - Don't use shared memory.\n");
				printf("/scale   - <1-255> Set window scale\n");
				printf("/x_scale - <1-255> Set x-scale\n");
				printf("/y_scale - <1-255> Set y-scale\n");
#endif
#ifdef MSDOS_SYSTEM
				printf("/mono    - mono EGA mode (no screen)\n");
#endif
				printf("<filename> If the file has a .sms");
				printf(" or a .gg extension it");
				printf(" will be accepted.\n");
				printf("\nPress F1 when in the emulator");
				printf(" for the help screen.\n");
				release_mem();
				exit(1);
			}
			if(!(strcmp(temp_str,"delay")))
			{
				arg_num++;
				slow_down=atoi(param[arg_num]);
			}
			if(!(strcmp(temp_str,"bp")))
			{
				arg_num++;
				breakpoint=atoi(param[arg_num]);
			}
			if(!(strcmp(temp_str,"fm")))
			{
				fm_present=1;
			}
			if(!(strcmp(temp_str,"jap")))
			{
				japan=1;
			}
			if(!(strcmp(temp_str,"nojoy")))
			{
				joy_present=255;
			}
			if(!(strcmp(temp_str,"frame")))
			{
				arg_num++;
				frame_skip=atoi(param[arg_num]);
				param_frame_skip=1;
			}
			if(!(strcmp(temp_str,"li")))
			{
				arg_num++;
				LI_method=atoi(param[arg_num]);
				if(LI_method>1) LI_method=0;
			}
			if(!(strcmp(temp_str,"ggpad")))
			{
				ggpad=1;
			}
			if(!(strcmp(temp_str,"p2joy")))
			{
				joy1_is_p2=1;
			}
			if(!(strcmp(temp_str,"bswap")))
			{
				button_swap=1;
			}
			if(!(strcmp(temp_str,"ggbig")))
			{
				big_gg=1;
			}
			if(!(strcmp(temp_str,"quiet")))
			{
				all_sound_on=UseAdlib=0;
			}
#ifndef NON_WINDOWS
			if(!(strcmp(temp_str,"noshm")))
			{
				UseSHM=0;
			}
			if(!(strcmp(temp_str,"scale")))
			{
				arg_num++;
				x_scale=y_scale=atoi(param[arg_num]);
			}
			if(!(strcmp(temp_str,"x_scale")))
			{
				arg_num++;
				x_scale=atoi(param[arg_num]);
			}
			if(!(strcmp(temp_str,"y_scale")))
			{
				arg_num++;
				y_scale=atoi(param[arg_num]);
			}
#endif
#ifdef MSDOS_SYSTEM
			if(!(strcmp(temp_str,"mono")))
			{
				bitpix=Scr_Msb_First=1;
				bytes_pp=0;
			}
#endif
			if(!(strcmp(temp_str,"flip")))
			{
				mono_mode^=1;
			}
			if(!(strcmp(temp_str,"nullr")))
			{
				set_null_modem();
				set_auto_answer();
			}
			if(!(strcmp(temp_str,"nullt")))
			{
				set_null_modem();
				set_dial("1");
			}
			if(!(strcmp(temp_str,"com")))
			{
				arg_num++;
				set_com(atoi(param[arg_num]));
			}
			if(!(strcmp(temp_str,"baud")))
			{
				arg_num++;
				set_baud(atoi(param[arg_num]));
			}
			if(!(strcmp(temp_str,"port")))
			{
				arg_num++;
				set_port(param[arg_num]);
			}
			if(!(strcmp(temp_str,"irq")))
			{
				arg_num++;
				set_irq(atoi(param[arg_num]));
			}
			if(!(strcmp(temp_str,"dial")))
			{
				arg_num++;
				set_dial(param[arg_num]);
			}
			if(!(strcmp(temp_str,"receive")))
			{
				set_auto_answer();
			}
			if(!(strcmp(temp_str,"top")))
			{
				arg_num++;
				TOP_LINE=atoi(param[arg_num]);
			}
		}
		else
		{
			strcpy(temp_str,param[arg_num]);
			if(!different_extension(".sms",temp_str))
			{
				strcpy(the_path,temp_str);
				gg_mode=0;
				if(!(open_sms()))
				{
					halt=0; /* Re-enable processor for new snap */
				}
				else
				{
					for(x=0;x<8;x++)
					{
						SRAMR[x]=DUMMY_MEM;
						SRAMW[x]=DUMMY_MEM;
					}
				}
				file_valid=1;
				quit=DONT_QUIT;
			}
			if(!different_extension(".gg",temp_str))
			{
				strcpy(the_path,temp_str);
				gg_mode=1;
				if(!(open_sms()))
				{
					halt=0; /* Re-enable processor for new snap */
				}
				else
				{
					for(x=0;x<8;x++)
					{
						SRAMR[x]=DUMMY_MEM;
						SRAMW[x]=DUMMY_MEM;
					}
				}
				file_valid=1;
				quit=DONT_QUIT;
			}
			if(!file_valid)
			{
				printf("File did not .sms or .gg");
				printf(" extension, so I did not know\n");
				printf("how to deal with it.\n");
			}
		}
		arg_num++;
	}
	if(file_valid==1) skip_reset=255;
}
