/******************************************/
/**                                      **/
/**          SMS_VAR Portable File       **/
/**                                      **/
/**          (C) James McKay 1996        **/
/**                                      **/
/**    This software may not be used     **/
/**    for commercial reasons, the code  **/
/**    may not be modified or reused     **/
/**    without permission.               **/
/**                                      **/
/******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXPATH 200
/*
#define DONT_QUIT 0
#define QUIT_HELP 1
#define QUIT_NMI 2
#define QUIT_RESET 3
#define QUIT_JOY  4
#define QUIT_LOAD 5
#define QUIT_SAVE 6
#define QUIT_TAP  7
#define QUIT_VOC  8
#define QUIT_COMPLETELY 10
#define QUIT_SOUND 11
#define QUIT_TALK 12
*/
#define SET_CF af.B.l|=1   /* set Cf */
#define RES_CF af.B.l&=254 /* reset Cf */

#define SET_NF af.B.l|=2   /* set Nf */
#define RES_NF af.B.l&=253 /* reset Nf */

#define SET_PF af.B.l|=4   /* set Pf */
#define RES_PF af.B.l&=251 /* reset Pf */

#define SET_3F af.B.l|=8   /* set bit 3 of F */
#define RES_3F af.B.l&=247 /* reset bit 3 of F */

#define SET_HF af.B.l|=16  /* set Hf */
#define RES_HF af.B.l&=239 /* reset Hf */

#define SET_5F af.B.l|=32  /* set bit 5 of F */
#define RES_5F af.B.l&=223 /* reset bit 5 of F */

#define SET_ZF af.B.l|=64  /* set Zf */
#define RES_ZF af.B.l&=191 /* reset Zf */

#define SET_SF af.B.l|=128 /* set Sf */
#define RES_SF af.B.l&=127 /* reset Sf */

#define P254 0,254
#define P32765 127,253

UC dump_y[64];
UC dump_x[64];
word stored_sp_y;
word breakpoint;
UC int_50=0, screen_up=0, scr_driver=0, test_count=0, test_speed=0;
UC param_frame_skip=0;

UC in_ret, in_port_hi, in_port_lo;
UC out_port_hi, out_port_lo, out_byte;
word mps_oset;
UC mps_bpval;

char *copyright_legal_thingy="(C) James McKay 1996";
char *version_no="Massage V0.61 By James McKay";

UC a_replay_on[MAX_A_REPLAY];
word a_replay_address[MAX_A_REPLAY];
UC a_replay_poke[MAX_A_REPLAY];
char a_replay_str[MAX_A_REPLAY][10];

UC japan=0;

UC fm_chip[256], fm_reg=0, fm_present=0;

UC left_clip=0, sprite_left=0, screen_on=1;
UC top_2_lock=0, right_8_lock=0;

UC old_vreg128=0, old_vreg129=0, old_vreg130=0, old_vreg131=0;
UC old_vreg132=0, old_vreg133=0, old_vreg134=0, old_vreg135=0;
UC old_vreg138=255, old_x_scroll=0, old_y_scroll=0;
UC old_first_y=0;

UC vreg128=0, vreg129=0, vreg130=0, vreg131=0;
UC vreg132=0, vreg133=0, vreg134=0, vreg135=0;
UC vreg138=255, x_scroll=0, y_scroll=0;
UC waiting_191=0, first_191=0;
word next_int_line=0/*311*/;
UC port0=128, port63=255, port220=255, port221=31, port222=255, port242=0;

UC port1=255, port2=255, port3=255, port4=255, port5=4;
UC send_port1=0, send_port3=0, read_port4=0;

UC rom_limit=0, line_int=0, background_counter=255;
UC vdp_pal=0;
word TOP_LINE=304;
word vdp_and=0x3FFF;
word vdp_addr=0/*vdp_addr=0x4000*/;
UC vblank_optional=0, int_255=1;

word time_taken, big_gg=0, time_p, time_s_ggs, time_s_ggb;
word time_s_sms, time_d;

unsigned long msb_bspread3[256], msb_bspread2[256];
unsigned long msb_bspread1[256], msb_bspread0[256];
unsigned long lsb_bspread3[256], lsb_bspread2[256];
unsigned long lsb_bspread1[256], lsb_bspread0[256];

UC *L_BUF, *L_BUF2, *L_BUF3, *TL_BUF, *TL_BUF2, *TL_BUF3;
UC *TDL_BUF, *DL_BUF, *DL_BUF3;
word spr_point=0;

/* pair and quadruple defined in x128_end.c */

pair af,bc,de,hl,ir,ix,iy,pc,sp,af2,bc2,de2,hl2;
UC bit7_r;
char *error_str;

UC im=1;
UC iff1, iff2, halt, quit=0;
UC ROM_pager=0, ROM_4000=1, waiting_127=0, first_127=0;
UC cart_in_mem=0, BRAM_page=0;
word no_of_16k_pages=0;
UC gg_mode=0, *pal0, *pal1;
UC *tile_addr, *spr_tile_addr, *scr_map_addr, *sprite_y, *sprite_x;

UC ggpad=0, joy1_is_p2=0, button_swap=0;

word vline=0;
word t_state=0;
word t_states_per_line=228;
word s_lines=311;
UC LI_method=0, ret_to_help=0, skip_reset=0;
UC frame_skip=2, try_100=1;
word slow_down=0;
word mwtemp;

UC adlib_present=0, all_sound_on=1;

pair ptemp;
quadruple qtemp;

word PSG[8];

FILE *handle, *t_handle, *d_handle, *p_handle, *s_handle;

UC VOC_file_in_open, VOC_file_out_open=0, VOC_paused=1;
char drives[27][4];

int global_index=0;
int sna_index, snap_index, tap_index, dat_index, snap_index=0;

char the_path[MAXPATH], the_sna_path[MAXPATH];
char the_tap_path[MAXPATH], the_sav_path[MAXPATH];
char prev_dir[MAXPATH], the_temp_file[MAXPATH];
char the_psg_path[MAXPATH], the_snap_path[MAXPATH];
char the_dump_path[MAXPATH];

UC calc_checksum, TAP_file_open=0;

word vga_x_y[192]; /* the list of VGA line addresses (indented) in X mode */

UC reverse_attr[128];

UC fore_attrib[256];
UC back_attrib[256];
UC parity[256];    /* All the parity for all possibilities (0 or 4) */
word spline[192];  /* spectrum offset to the start of a line */

UC  ormask[8]={1,2,4,8,16,32,64,128};

UC   red[16]={0, 0,55,57, 0, 0,52,50,0, 0,60,63, 0, 0,63,63};
UC green[16]={0, 0, 0, 0,53,53,52,50,0, 0, 0, 0,60,63,63,63};
UC  blue[16]={0,40, 0,45, 0,53, 0,50,0,43, 0,55, 0,63, 0,63};

/* Z80 Table Arrays */
/*UC rlca_f[2][256];
UC rlca_a[2][256];
UC rrca_f[2][256];
UC rrca_a[2][256];*/

UC rlca_f[256];
UC rlca_a[256];
UC rrca_f[256];
UC rrca_a[256];

/*UC rla_f[2][256];
UC rla_a[2][256];
UC rra_f[2][256];
UC rra_a[2][256];*/

UC rla_f0[256];
/*UC rla_f1[256];*/
UC rla_a0[256];
UC rla_a1[256];
UC rra_f0[256];
/*UC rra_f1[256];*/
UC rra_a0[256];
UC rra_a1[256];

UC daa_f[8][256];
UC daa_a[8][256];

UC inc_f[256];
/*UC inc_a[256];*/
UC dec_f[256];
/*UC dec_a[256];*/

/*UC rlcr_f[2][256];
UC rlcr_a[2][256];
UC rrcr_f[2][256];
UC rrcr_a[2][256];*/

UC rlcr_f[256];
UC rlcr_a[256];
UC rrcr_f[256];
UC rrcr_a[256];

/*UC rlr_f[2][256];
UC rlr_a[2][256];
UC rrr_f[2][256];
UC rrr_a[2][256];*/

UC rlr_f0[256];
UC rlr_f1[256];
UC rlr_a0[256];
UC rlr_a1[256];
UC rrr_f0[256];
UC rrr_f1[256];
UC rrr_a0[256];
UC rrr_a1[256];

/*UC sla_f[2][256];
UC sla_a[2][256];
UC sra_f[2][256];
UC sra_a[2][256];
UC sll_f[2][256];
UC sll_a[2][256];
UC srl_f[2][256];
UC srl_a[2][256];*/

UC sla_f[256];
UC sla_a[256];
UC sra_f[256];
UC sra_a[256];
UC sll_f[256];
UC sll_a[256];
UC srl_f[256];
UC srl_a[256];

UC bit_f0[256];
/*UC bit_a0[256];*/
UC bit_f1[256];
/*UC bit_a1[256];*/
UC bit_f2[256];
/*UC bit_a2[256];*/
UC bit_f3[256];
/*UC bit_a3[256];*/
UC bit_f4[256];
/*UC bit_a4[256];*/
UC bit_f5[256];
/*UC bit_a5[256];*/
UC bit_f6[256];
/*UC bit_a6[256];*/
UC bit_f7[256];
/*UC bit_a7[256];*/

UC ora_table[256];
UC xora_table[256];
UC anda_table[256];
UC in_table[256];
UC add8_table[256];
UC sub8_table[256];
UC cpsub8_table[256];
UC add_HVC[256];
UC sub_HVC[256];
UC add16_VNC[256];
UC sub16_VNC[256];

/* defs for keyboard */

#define StoB 0 /* Space to B */
#define EtoH 1 /* Enter to H */
#define PtoY 2
#define N0toN6 3 /* 0 to 6 */
#define N1toN5 4 /* 1 to 5 */
#define QtoT 5
#define AtoG 6
#define CtoV 7 /* Caps shift to V */

#define off0 1
#define on0  254
#define off1 2
#define on1  253
#define off2 4
#define on2  251
#define off3 8
#define on3  247
#define off4 16
#define on4  239

UC *ROM[256];
UC *SRAMR[8]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
UC *SRAMW[8]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
UC *BRAM[2];

/*UC *SRAMR0, *SRAMR1, *SRAMR2, *SRAMR3;
UC *SRAMR4, *SRAMR5, *SRAMR6, *SRAMR7;
UC *SRAMW0, *SRAMW1, *SRAMW2, *SRAMW3;
UC *SRAMW4, *SRAMW5, *SRAMW6, *SRAMW7;*/

UC *VIDEO=NULL;
UC *VRAM=NULL;
UC *VPAL=NULL;

UC *RAM_C000=NULL;
UC *DUMMY_MEM=NULL;
UC *ROM48=NULL;

UC *SP_SCREEN=NULL;

UC *old_screen=NULL;
UC *old_tile=NULL;
UC old_machine_mode;

UC host_pal[64];

UC *scr_table, *border_table;

#ifdef MSDOS_SYSTEM
word width_of_scr=320, height_of_scr=192, byte_width_of_scr;
word width_of_nib, width_of_table_line;
word width_of_half_border;
UC x_scale=1, y_scale=1, bytes_pp;
UC bitpix, Scr_Msb_First=0, mono_mode=0;
#endif

UC CONTENDED[8];

UC *BUFFER=NULL;
UC *CSET=NULL;
#ifdef MSDOS_SYSTEM
#ifndef NO_BUFFER
UC *XBuf=NULL;
#endif
#endif
UC *FNAME=NULL;

UC SKey[8]; /* The 8 keyboard bytes for the Spectrum */
